#COMPILE EXE                                      
#DIM ALL                                                               
'#DEBUG DISPLAY ON                                            
'%Unicode = 1
#INCLUDE "appHelp.inc"                     
#INCLUDE "Win32api.inc"                                                            
#INCLUDE "edm32.inc"                                                 
'#INCLUDE "debug.inc"                                                      
'#RESOURCE RES "myPBEditor.res"
#RESOURCE pbr "myPBEditor.pbr"

$verNo = "1.52"   
               
'Version History  ---------------------------------------------------------------------------------
'ver 1.15 (01/29/2012)
' - files loaded by COMMAND$ are not kept for auto loading next time (loadedByCmd variable)
' - remember folder of last loaded file when loading another file
' - added uninstall file to "Program Files\cgdSoftware\myPBEditor\"
' - corrected problem of resizing edit pages and vert scrollbar losing its place
'ver 1.16 (02/05/2012)
' - corrected problem when CTRL+Y with empty line
' - added $DQ for compiling files with long names (see edmCompile)
' - corrected problem reading in files (forgot to initialize n = 0)
' - corrected scroll bar width when opening file or new file (dialog post WM_SIZE)
' - clear statusbar when there are no tabs, updateStatus when tabs are closed
'ver 1.17 (02/10/2012)
' - added for empty line, backspace with tabsize spaces (shft+backspace for single space)
' - added shft+space for unselected text, nondestructive backspace (reverse of space)
' - added option for confirming exit
'ver 1.18 (02/10/2012)
' - File > Exit message handler added (was left out)
' - Find text in all files cycled tabs continuously when none found (nReplace deleted)
' - corrected Goto fcn/sub directly (needed compare with LCASE$)
'ver 1.19 (02/20/2012)
' - corrected problem centering tab text with SaveFileAs
' - start folder in SaveFileAs should be dataFolder rather than a 'Program Files' subfolder
' - corrected F4 to work with selected word (cursor put at start of selection)
' - prevent x = -32000, y = -32000, wi = 0, ht = 0 retrieval from iniFile
'ver 1.20 (02/22/2012)
' - fixed problem with tabSpaces not getting set
' - replaced 'confirm' option with 'beep' and added 'Cancel' button to exit dialog
' - added code for the option of one instance only
'ver 1.21 (02/28/2012)
' - fixed problem of closing all windows from Windows Taskbar (save iniFile with first instance only)
'ver 1.22 (03/01/2012)
' - fixed shft+space problem of double space movement
' - added single line selection to the way multiline block action responds (no difference now)
' - added new option confineCaret to constrain caret to line length
' - added new options for keywords: ignore case, upper case, mixed case, lower case
' - added new options: 'syntax coloring' and 'show grid lines'
' - fixed mixed case for text selection (Ctrl+M has char code of 13, same as RETURN)
' - fixed problem of adding subfolder "0" when no backup folder was prescribed
' - redefined 'Edit' menu and added 'View' menu
'ver 1.23 (03/04/2012)
' - fixed problem of not being able to select lines with keyboard (ver 1.22 spurious code pasted in)
' - fixed problem of clicking beyond the end of line when using the option to allow it
'ver 1.24 (03/10/2012)
' - fixed problem of top line changing when compiled with no errors
' - fixed problem with Return on selected line when cursor is beyond line length
' - fixed menu states when no files are loaded
' - improved algorithm for reading the iniFile, loading added data last
' - added new option to wrap caret at line ends around to next/prev line
'ver 1.25 (03/15/2012)
' - fixed unNamed source to work like test code (was giving error code of 496)
' - fixed problem when loading a filename already loaded (text of selected tab was destroyed)
'ver 1.26 (03/21/2012)
' - reduced flicker when loading multiple tab pages by not showing the hidden tab pages
'   added SUB getFileText() and array pageLoaded()
'   used edmSetText() and getFileText() instead of SendMessage with EDM_LOADFILE
' - reduced flicker when resizing window by minimizing calls to GetDC()
' - improved moveTabs() and WM_SYSCOMMAND code
'ver 1.27 (03/31/2012)
' - effectively eliminated toolbar flicker
' - fixed problem with saving new file (start folder in DISPLAY SAVEFILE)
' - fixed problen with 'subsequentInst' and 'loadedByCmd' for opening and saving iniFile
'ver 1.28 (05/02/2012)
' - fixed problem with startFolder when opening file (should use dataFolder as default)
' - fixed problem with updating fileText() when changing tabs
' - fixed problem with new file losing info when switching to another tab
'ver 1.30 (05/30/2012)
' - added feature to select loaded files as a project
' - changed F2 for set/reset bookmark, and Ctrl+F2 for moving to next bookmark
'ver 1.31 (06/30/2012)
' - added cancel option when closing tab with closeFile() sub
' - fixed caret beyond line length problem of reporting change (due to adding spaces)
' - made ESC key to unselect any selected text
' - added new getLineCase() routine so that proper case for text gets printed
' - corrected problem with size of new file (wi-10, ht-100) in CreateEdm32edit()
'ver 1.32 (08/04/2012)
' - fixed getLineCase() routine so that comments retain their original case
' - allow adding characters past end of line while confining caret
' - allow pasting text past end of line while confining caret
'ver 1.33 (04/11/2013)
' - fixed Undo in Edit menu (Ctrl+Z did work though)
' - fixed moveTabLeft/Right when contents have been changed
' - removed Clear command and rearranged Edit & View menu items
' - fixed pasting past line length when text to replace selection
' - fixed delete and backspace when caret is past line length
'ver 1.34 (04/13/2013)
' - check that help and keyword files are in the data folder
' - corrections for shft+(arrow keys/backspace) ...when selecting past line length
'ver 1.35 (04/14/2013)
' - corrections for shft+(arrow keys/delete) problems when selecting past line length
'   (these problems resulted in forced closures of the editor)
' - delete and backspace should return cursor to end of line when selecting past line length
'ver 1.36 (04/16/2013)
' - final corrections in ver 1.35 which should have been denoted by a later version
'ver 1.37 (05/19/2013)
' - corrected Ctrl+Y for yanking an empty line                
' - corrected startFolder when opening new file
'ver 1.40 (05/30/2013)
' - manifest security section used to keep from redirecting to VirtualStore\ProgramData\...
' - corrected problem of adding text to blank line at position other than start of line
' - added $DQ to all file and folder references in edmCompile() to accomodate spaces in filename
' - improved source code and resource compiling, while adding more messages
' - changed SHELL command to ShellExecute() in edmCompile() to preserve .manifest file security
'ver 1.41 (06/03/2013)
' - improved options by dimming certain fields (compile folders, as well as backup number and path)
'ver 1.42 (05/21/2014)
' - logFile should be killed when compiler error occurs or when compiling only
' - created saveIniFile() for a little better code organization
' - fixed problem with edited tab file displaying properly just after its loaded
' - fixed problem with detecting changed files during file closure... added array changes()
' - changed behavior of clicking 'code finder', always bring up dialog box
'ver 1.43 (06/01/2014)
' - had to abandon block space... user might really want to replace selection with space
' - fixed problem with tabbing backward over leading spaces (caret ends on tab position)
'ver 1.44 (06/05/2014)
' - minor corrections of Backspace and Tab key actions beyond end of line
' - improved action of Delete key beyond end of line (concatenates next line at caret position)
'ver 1.45 (07/11/2014)
' - print long line extending past right margin on next line (up to 1024 characters)
' - corrected filename that is printed at top of page
'ver 1.46 (12/10/2014)
' - corrected problem with replacing selected text when cursor is beyond end of selection
'ver 1.47 (04/27/2015)
' - corrected and improved code for displaying current procedure in statusbar 
'ver 1.48 (10/11/2015)
' - corrected error when finding nonmatching item from allFiles (ran out of resources)
' - corrected sub/function name in statusbar (part of parameters were displayed)
'ver 1.49 (03/03/2016
' - corrected backspace not working on first line (improved backspace action generally)
' - corrected problem of F3 not finding next hilited item (FindRepl dialog not closed properly)
' - corrected problem of not printing blank lines
' - corrected problem with cursor beyond line length for empty line (ctmMouseLButtonDown)
' - corrected serious problem replacing text (overran fileText memory allocation)
'ver 1.50 (03/10/2016
' - fixed tab file opening to wrong size
' - fixed iniFile not being saved properly (deleted iniFile in virtualstore)
' - fixed problem adding spaces and tabs to blank line
' - fixed problem deleting spaces and tabs with backspace and shft+tab  
'ver 1.51 (03/19/2016)                            
' - added opening prompt if running a subsequent instance of myPBEditor
' - back space past end of text without spaces deletes tab spaces ???
' - fixed problem of F4 when cursor is on routine with name containing "-" or "_"
' - fixed problem when clicking mouse on empty line (undid change I made before)
'ver 1.52 (10/07/2017)
' - fixed problem creating .res/.pbr files (CHDIR pbPath + "\winapi\")
' - removed opening prompt of subsequent instance of myPBEditor
' - added savFiles parameter to saveIniFile() to allow saving only options
' - changed out help file to mine with ".ahp" extension
'ver 1.52 (06/18/2019) ~ pending
' - change iniFile: any opened file, even opened by COMAND$, but not subsequently opened ones 
'=====================================================================================================
                            
'GLOBAL dbug AS LONG                       
       
%IDM_New          = 100  'Ctrl+N          
%IDM_Open         = 101  'Ctrl+O                               
%IDM_Save         = 102  'Ctrl+S
%IDM_SaveAs       = 103
%IDM_SaveAll      = 104
%IDM_SaveProj     = 105
%IDM_Print        = 106  'Ctrl+P
%IDM_Close        = 107
%IDM_CloseAll     = 108
%IDM_Exit         = 109  'Alt+F4

%IDM_Undo         = 120  'Ctrl+Z
%IDM_Delete       = 122
%IDM_SelectAll    = 123  'Ctrl+A
%IDM_SelectLine   = 124  'Ctrl+L
%IDM_Cut          = 125  'Ctrl+X
%IDM_Copy         = 126  'Ctrl+C
%IDM_Paste        = 127  'Ctrl+V

%IDM_SelUcase     = 131  'Ctrl+U     (case selected)
%IDM_SelLcase     = 132  'Ctrl+L     (case selected)
%IDM_SelMcase     = 133  'Ctrl+M     (case selected)
%IDM_SelTcase     = 134  'Ctrl+T     (case selected)

%IDM_Comment      = 141  'Ctrl+Q     (block selected)
%IDM_unComment    = 142  'Shft+Q     (block selected)
%IDM_Tab          = 143  'Tab        (block selected)
%IDM_unTab        = 144  'Shft+Tab   (block selected)

%IDM_MoveTabRight = 151
%IDM_MoveTabLeft  = 152
%IDM_Syntax       = 153  'Ctrl+H
%IDM_GridLines    = 154  'Ctrl+G

%IDM_Find         = 160  'Ctrl+F
%IDM_FindNext     = 161  'F3
%IDM_FindPrev     = 162  'Shft+F3
%IDM_Replace      = 163
%IDM_GotoLine     = 164
%IDM_CodeFinder   = 165  'F4
%IDM_CodeFindRtn  = 166  'Shft+F4 to return)
%IDM_SetBkMk      = 167  'F2                        
%IDM_NextBkMk     = 168  'Ctrl+F2
%IDM_PrevBkMk     = 169  'Shft+F2
%IDM_ClrBkMks     = 170  'Ctrl+Shft+F2

%IDM_Compile      = 175  'F11
%IDM_CompileRun   = 176  'F12
%IDM_Options      = 177

%IDM_EdtHelp      = 180
%IDM_PBHelp       = 181  'F1
%IDM_SDKhelp      = 182
%IDM_About        = 183

%IDM_CloseTab     = 191
%IDM_MoveRight    = 192
%IDM_MoveLeft     = 193

%IDC_Toolbar      = 200
%IDC_TBnew        = 201
%IDC_TBopen       = 202
%IDC_TBsave       = 203
%IDC_TBprint      = 204
%IDC_TBcut        = 205
%IDC_TBcopy       = 206
%IDC_TBpaste      = 207
%IDC_TBfind       = 208
%IDC_TBfindRepl   = 209
%IDC_TBsubFcn     = 210
%IDC_TBcompile    = 211
%IDC_TBcompRun    = 212
%IDC_TBhelp       = 213
%IDC_TBline       = 214

%IDC_Status       = 250
%IDC_Whole        = 251
%IDC_Case         = 252
%IDC_Keep         = 253
%IDC_CurFile      = 254
%IDC_AllFiles     = 255
%IDC_CurSubFcn    = 256
%IDC_Direction    = 257
%IDC_Up           = 258
%IDC_Down         = 259
%IDC_Replace      = 260
%IDC_ReplaceAll   = 261
%IDC_What         = 262
%IDC_WithLabel    = 263
%IDC_With         = 264

%IDC_PB8          = 301
%IDC_PB9          = 302
%IDC_PB10         = 303
%IDC_PB8Path      = 304
%IDC_PB9Path      = 305
%IDC_PB10Path     = 306
%IDC_PB8Btn       = 307
%IDC_PB9Btn       = 308
%IDC_PB10Btn      = 309
%IDC_Fontsize     = 320
%IDC_LineSpac     = 321
%IDC_Tabspaces    = 322
%IDC_TBsize       = 323
%IDC_OneInst      = 331
%IDC_beepOpt      = 332
%IDC_CompMsg      = 333
%IDC_Confine      = 334
%IDC_WrapCaret    = 335
%IDC_Syntax       = 336
%IDC_GridLines    = 337
%IDC_KWIgnore     = 351
%IDC_KWucase      = 352
%IDC_KWmixed      = 353
%IDC_KWlcase      = 354
%IDC_Backups      = 361
%IDC_NumBackups   = 362
%IDC_BackupPath   = 363
%IDC_Reset        = 364
%IDC_SubFcnList   = 370

%IDC_Tab          = 400 'tab control (up to 50)
%IDC_ProjFile     = 450 'project file (up to 50)

GLOBAL hDlg, hTab, hMenu, hMouseTabMenu, hMouseEdtMenu, hEdit, hPage AS LONG
GLOBAL hFileMenu, hEditMenu, hViewMenu, hSrchMenu, hRunMenu, hImageList AS LONG
GLOBAL x, y, wi, ht, thisTab, numTabs, clickedTab, displayLines, subsequentInst, lastSub AS LONG
GLOBAL gOrigEditProc, gOrigTabProc, startPos, endPos, numFiles, lastTab AS LONG
GLOBAL subFcnRange, allFiles, saveThisTab, nReplace, pbVer, TBsize, gErr AS LONG                  
GLOBAL fontSize, tabSpaces, oneInst, beepOpt, compMsg, confine, wrapCaret, whole AS LONG
GLOBAL syntax, keywordCase, gridLines, backups, numBackups, mayGotoSub AS LONG
global selBlockFirst, selBlockLast, selBlockLeft, selBlockRight, hMutex as long
GLOBAL xTab, yTab AS WORD, pidRun, pidHelp AS DWORD
GLOBAL PB8Path, PB9Path, PB10Path AS STRING
GLOBAL dataFolder, findTxtLast, thisFile, iniFile, edtHelp AS STRING
GLOBAL rcCompiler, resConvert, pbCompiler, inclPath, pbPath, lineSpac, backupPath AS STRING
GLOBAL pbHelp, sdkHelp AS ASCIIZ * 255    
GLOBAL pageHandles(), edmHandles(), pageLoaded() AS LONG
GLOBAL fileNames(), fileText(), inputFiles() AS STRING

DECLARE FUNCTION HtmlHelp LIB "hhctrl.ocx" ALIAS "HtmlHelpA" _
          (BYVAL LONG, ASCIIZ, BYVAL LONG, BYVAL LONG ) AS LONG
DECLARE FUNCTION CreateMutexA LIB "Kernel32.dll" ALIAS "CreateMutexA" _
    (lpMutexAttributes AS SECURITY_ATTRIBUTES, BYVAL bInitialOwner AS LONG, _
    lpName AS ASCIIZ) AS DWORD                                                               


FUNCTION PBMAIN()
   LOCAL nStyle, fileNo, w, h AS LONG
   LOCAL ti as string
   local mutexName AS ASCIIZ *64
   local windowName AS ASCIIZ *32
   LOCAL v AS STRING*4

   DIALOG FONT "arial", 10

   'define Windows data folder
   dataFolder = specialFolder(%CSIDL_COMMON_APPDATA)
   IF LEN(dataFolder) = 0 THEN dataFolder = "C:\My Documents"
   dataFolder = dataFolder + "\cgdSoftware\myPBeditor\"
   IF ISFOLDER(dataFolder) = 0 THEN createFolder dataFolder
   iniFile = dataFolder + "myPBeditor.ini"
   'edtHelp = dataFolder + "myPBEditor.chm"
   edtHelp = dataFolder + "myPBEditor.ahp"
   windowName = "my PBEditor"                                                   

   'check that help and keyword files are in dataFolder
   'IF ISFILE(edtHelp) = 0 AND ISFILE("myPBEditor.chm") THEN FILECOPY "myPBEditor.chm", edtHelp
   IF ISFILE(edtHelp) = 0 AND ISFILE("myPBEditor.ahp") THEN FILECOPY "myPBEditor.ahp", edtHelp
   IF ISFILE(dataFolder + "pb08keys.txt") = 0 THEN _
           IF ISFILE("pb08keys.txt") THEN FILECOPY "pb08keys.txt", dataFolder + "pb08keys.txt"
   IF ISFILE(dataFolder + "pb09keys.txt") = 0 THEN _                                              
           IF ISFILE("pb09keys.txt") THEN FILECOPY "pb09keys.txt", dataFolder + "pb09keys.txt"
   IF ISFILE(dataFolder + "pb10keys.txt") = 0 THEN _
           IF ISFILE("pb10keys.txt") THEN FILECOPY "pb10keys.txt", dataFolder + "pb10keys.txt"

   'detect if multiple instances
   fileNo = FREEFILE                                           
   OPEN iniFile FOR INPUT LOCK READ AS #fileNo                            
   INPUT #fileNo, oneInst
   CLOSE #fileNo
   
   windowName = "my PBEditor"
   mutexName = "myPBEditor " + $verNo + " by chasDietz"
   hMutex = CreateMutex(BYVAL %NULL, BYVAL %NULL, BYVAL VARPTR(mutexName))
   IF hMutex THEN
      IF GetLastError = %ERROR_ALREADY_EXISTS THEN 'instance already running
         IF oneInst THEN 'option specifying only one instance allowed
            msgbox "Instance of myPBEditor already running", %mb_iconerror, "One Instance Only"
            CloseHandle hMutex: EXIT FUNCTION
         ELSE 'multiple instances allowed
            subsequentInst = 1                                                 
         END IF
      end if                                                          
   end if                                                                 
   
   IF ISFILE(iniFile) THEN 'load iniFile 
      openIniFile()
   ELSE 'iniFile not found, take defaults             
      x = w/8: y = h/10: wi = .60*w: ht = .75*h
      fontSize = 10: lineSpac = "1.500": tabSpaces = 3: TBsize = 24
      'try to determine the PB version
      IF ISFOLDER("C:\pbwin10\bin") THEN
         pbVer = 10: pbPath = "C:\pbWin10"
      ELSEIF ISFOLDER("C:\pbwin90\bin") THEN
         pbVer = 9: pbPath = "C:\pbWin90"
      ELSE
         pbVer = 8: pbPath = "C:\pbWin80"
      END IF
      syntax = 1
      keywordCase = 1
      numBackups = 8
      backupPath = "Backups"
   END IF 
      
   'define window size & location  
   DESKTOP GET CLIENT TO w, h
   IF x < 0 OR x + wi > w THEN x = w/8
   IF y < 0 OR y + ht > h THEN y = h/10
   IF wi <= .10*w OR x + wi > w THEN wi = .60*w
   IF ht <= .12*h OR y + ht > h THEN ht = .75*h 
   loadKeywords

   IF ISFOLDER(pbPath) THEN 'define files & folders for editor
      pbCompiler = pbPath + "\bin\pbWin.exe"
      rcCompiler = pbPath + "\bin\rc.exe"
      resConvert = pbPath + "\bin\pbRes.exe"
      sdkHelp = pbPath + "\WinAPI\win32.hlp"
      pbHelp = pbPath + "\bin\pbWin.chm"
      IF PBver = 8 THEN pbHelp = pbPath + "\bin\pbWin.hlp"
      inclPath = pbPath + "\winAPI\"
   END IF

   ti = windowName
   nStyle = %WS_SYSMENU OR %WS_CAPTION OR %WS_THICKFRAME OR %WS_MAXIMIZEBOX OR %WS_MINIMIZEBOX
   DIALOG NEW PIXELS, 0, ti, x, y, wi, ht, nStyle TO hDlg   'wi, ht are client dimensions
   DIALOG SET COLOR hDlg, -1, -1
   addMenu
   addToolbar
   addKeybdAccels
   nStyle = %TCS_FIXEDWIDTH OR %TCS_FOCUSONBUTTONDOWN
   CONTROL ADD TAB, hDlg, %IDC_TAB, "", 0, 16+TBsize, wi, ht, nStyle
   xTab = 130: yTab = 25
   CONTROL SEND hDlg, %IDC_Tab, %TCM_SETITEMSIZE, 0, MAK(DWORD, xTab, yTab)
   CONTROL ADD STATUSBAR, hDlg, %IDC_Status, "", 0, 0, 0, 0
   DIALOG SHOW MODAL hDlg CALL PBmainProc
END FUNCTION

'callback function used by all Tab dialogs
CALLBACK FUNCTION PBmainProc()
   LOCAL fileNo, flags, changed, hFont, i, n, x, y AS LONG
   LOCAL startFolder, filter, t, f, s AS STRING
   LOCAL P AS TOOLTIPTEXTW PTR
   STATIC showDlg, hToolbar, TBredraw, loadedByCmd AS LONG
   STATIC savedTop, savedLine, savedPos, savedTxtPos, timerID, mouseDown AS LONG
   SELECT CASE CB.MSG
      CASE %WM_INITDIALOG
         thisFile = REMOVE$(COMMAND$, """")
         IF LEN(thisFile) THEN loadedByCmd = -1
         hTab = GetDlgItem(CB.HNDL, %IDC_Tab)
         hToolbar = GetDlgItem(CB.HNDL, %IDC_Toolbar)
         STATUSBAR SET PARTS CB.HNDL, %IDC_Status, wi - 280, 200, 80
         updateStatus: whole = 1
         gOrigTabProc = SetWindowLong(hTab, %GWL_WNDPROC, CODEPTR(subClassTabProc))
         DIALOG POST CB.HNDL,%WM_USER+500, 0, 0
      CASE %WM_USER+500 'show dialog for first time
         FOR i = 1 TO 13 'disable most of the toolbar until a file is loaded
            IF i >= 3 AND i <= 12 THEN n = %TBSTATE_DISABLED ELSE n = %TBSTATE_ENABLED
            TOOLBAR SET STATE hDlg, %IDC_Toolbar, BYCMD %IDC_Toolbar + i, n
         NEXT i
         setMenuState(0) 'disable most of the menus until a file is loaded
         DIALOG SET CLIENT hDlg, wi, ht
         IF loadedByCmd AND LEN(thisFile) THEN
            openTheFile thisFile                                      
         ELSEIF subsequentInst = 0 THEN
            n = 0
            FOR i = 1 TO numFiles                           
               IF ISFILE(inputFiles(i)) THEN                               
                  INCR n: addFile inputFiles(i)
                  inputFiles(n) = inputFiles(i)                           
               END IF
            NEXT i
            numFiles = n
         ELSE 'multiple instances running
            numFiles = 0
         END IF 
         IF numFiles THEN
            thisTab = 1
            thisFile = fileNames(1)
            hEdit = edmHandles(1)
            TAB SELECT CB.HNDL, %IDC_Tab, 1
            edmSetText hEdit, fileText(1)
            pageLoaded(1) = 1
            SendMessage hEdit, %EDM_SETTOPLINE, 0, 1
            SendMessage hEdit, %EDM_SETSEL, 0, 0
            SetFocus hEdit: updateStatus
         END IF                                                         
         showDlg = 1
         DIALOG POST CB.HNDL, %WM_SIZE, 0, 0
      CASE %WM_SIZE 
         IF showDlg THEN
            DIALOG GET CLIENT CB.HNDL TO wi, ht
            CONTROL SET SIZE CB.HNDL, %IDC_Tab, wi, ht-62
            CONTROL SET SIZE hPage, %IDC_Tab + thisTab, wi-10, ht-100
            IF hEdit THEN displayLines = SendMessage(hEdit, %EDM_LINESPERWINDOW, 0, 0)
            STATUSBAR SET PARTS CB.HNDL, %IDC_Status, wi - 280, 200, 80
            updateStatus
            IF wi < 470 THEN TBredraw = 1                                                                             
            IF mouseDown THEN 'eliminate toolbar flicker
               KillTimer CB.HNDL, timerID
               timerID = SetTimer(CB.HNDL, BYVAL 0, 100, BYVAL 0)                   
               SendMessage hToolbar, %WM_SETREDRAW, 0, 0
            END IF
         END IF
      CASE %WM_SETCURSOR 'eliminate toolbar flicker
         IF HI(WORD, CB.LPARAM) = %WM_LBUTTONDOWN THEN
            mouseDown = 1
         ELSE
            mouseDown = 0
         END IF
      CASE %WM_TIMER 'eliminate toolbar flicker                                                       
         IF mouseDown = 0 OR TBredraw THEN
            TBredraw = 0
            KillTimer CB.HNDL, timerID
            SendMessage hToolbar, %WM_SETREDRAW, 1, 0
         END IF
      CASE %WM_NOTIFY
         hToolbar = GetDlgItem(CB.HNDL, %IDC_TOOLBAR)
         IF CB.NMHWND = SendMessage(hToolbar, %TB_GETTOOLTIPS, 0, 0) THEN  '-------- tooltip
            IF CB.NMCODE = %TTN_GETDISPINFOW THEN
               P = CB.LPARAM
               IF CB.NMID = %IDC_TBnew THEN @P.@lpszText = "New file"
               IF CB.NMID = %IDC_TBopen THEN @P.@lpszText = "Open file"
               IF CB.NMID = %IDC_TBsave THEN @P.@lpszText = "Save file"
               IF CB.NMID = %IDC_TBprint THEN @P.@lpszText = "Print file"   
               IF CB.NMID = %IDC_TBcut THEN @P.@lpszText = "Cut text"
               IF CB.NMID = %IDC_TBcopy THEN @P.@lpszText = "Copy text"
               IF CB.NMID = %IDC_TBpaste THEN @P.@lpszText = "Paste text"
               IF CB.NMID = %IDC_TBfind THEN @P.@lpszText = "Find text"
               IF CB.NMID = %IDC_TBfindRepl THEN @P.@lpszText = "Find + replace text"
               IF CB.NMID = %IDC_TBsubFcn THEN @P.@lpszText = "List subs/functions"
               IF CB.NMID = %IDC_TBcompile THEN @P.@lpszText = "compile file"
               IF CB.NMID = %IDC_TBcompRun THEN @P.@lpszText = "compile + Run"
               IF CB.NMID = %IDC_TBhelp THEN @P.@lpszText = "PowerBasic help"
            END IF
         END IF
         IF CB.WPARAM = %IDC_Tab THEN  '---------------------------------------- selected tab
            TAB GET SELECT CB.HNDL, %IDC_Tab TO thisTab
               thisFile = fileNames(thisTab)
               hEdit = edmHandles(thisTab)
               hPage = pageHandles(thisTab)
               CONTROL SET SIZE hPage, %IDC_Tab + thisTab, wi-10, ht-100
               IF pageLoaded(thisTab) = 0 THEN
                  edmSetText hEdit, fileText(thisTab)
                  pageLoaded(thisTab) = 1
               END IF                                        
               SetFocus hEdit
               updateStatus                                     
         END IF
      CASE %WM_COMMAND                                                           
         SELECT CASE CB.CTL
            CASE %IDM_New, %IDC_TBnew
               addFile dataFolder + "unNamed.bas"
               IF gErr THEN gErr = 0: EXIT FUNCTION
               s = "#COMPILE EXE" + $CRLF + "#DIM ALL" + $CRLF + "#INCLUDE ""wIN32api.inc""" _
                 + $CRLF + $CRLF + "FUNCTION PBMAIN()" + $CRLF + "" + $CRLF + "END FUNCTION"
               fileText(thisTab) = s
               edmSetText hEdit, fileText(thisTab)  'copy text into editor
               SendMessage hEdit, %EDM_SETCHANGED, 1, 0
               pageLoaded(thisTab) = 1
            CASE %IDM_Open, %IDC_TBopen
               FOR i = 1 TO numTabs 'startFolder is  the first 'bas' file folder listed in tabs
                  IF LCASE$(PATHNAME$(EXTN, fileNames(i))) = ".bas" THEN  'primary source file
                     startFolder = PATHNAME$(PATH, fileNames(i)): EXIT FOR
                  END IF
               NEXT i
               IF numTabs = 0 THEN 'PowerBasic folder when no files loaded yet
                  startFolder = pbPath
               ELSEIF LEN(startFolder) = 0 THEN 'path of first file of any type
                  startFolder = PATHNAME$(PATH, fileNames(1))
               END IF
               filter = CHR$("Source (*.bas, *.inc)", 0, "*.bas; *.inc", 0, _
                             "Resource (*.rc)", 0, "*.rc", 0, _
                             "Project (*.pbj)", 0, "*.pbj", 0, _
                             "All Files (*.*)", 0, "*.*", 0)
               flags = %OFN_FILEMUSTEXIST OR %OFN_HIDEREADONLY OR _
                       %OFN_LONGNAMES OR %OFN_EXPLORER OR %OFN_ENABLESIZING
               DISPLAY OPENFILE CB.HNDL, , , "Open File", startFolder, filter, "", "", flags TO f
               IF LEN(f) THEN openTheFile f
               SendMessage hEdit, %EDM_SETCHANGED, 0, 0
            CASE %IDM_Save, %IDC_TBsave
               n = MSGBOX("Save this file now?", %MB_ICONQUESTION OR %MB_YESNO, "Save File")
               IF n = %IDYES THEN saveFiles thisTab              
            CASE %IDM_SaveAs
               saveAsFile thisTab
            CASE %IDM_SaveAll
               n = MSGBOX("Save all files now?", %MB_ICONQUESTION OR %MB_YESNO, "Save All Files")
               IF n = %IDYES THEN saveFiles 0
            CASE %IDM_SaveProj
               saveAsProject
            CASE %IDM_Print, %IDC_TBprint
               printText
            CASE %IDM_Close, %IDM_CloseTab
               TAB GET SELECT CB.HNDL, %IDC_Tab TO thisTab
               IF CB.CTL = %IDM_Close THEN clickedTab = thisTab
               closeFile(clickedTab): updateStatus
            CASE %IDM_CloseAll
               closeFile(0): updateStatus
            CASE %IDM_Exit
               DIALOG SEND CB.HNDL, %WM_SYSCOMMAND, %SC_CLOSE, 0
            CASE %IDM_Undo
               SendMessage hEdit, %EDM_UNDO, 0, -1
            CASE %IDM_Delete
               ctmKeyDown hEdit, %VK_DELETE, -1
            CASE %IDM_SelectAll
               SendMessage hEdit, %EDM_SETSEL, 0, -1
               SendMessage hEdit, %EDM_Refresh, 0, 0
            CASE %IDM_SelectLine
               n = SendMessage(hEdit, %EDM_GETSELLENGTH, 0, 0)
               IF n THEN 'lcase selected text
                  SendMessage hEdit, %EDM_LCASE, 0, 1
               ELSE 'selectLine
                  SendMessage hEdit, %EDM_SelectLine, -1, 1
               END IF                                                  
            CASE %IDM_Cut, %IDC_TBcut
               n = SendMessage(hEdit, %EDM_GETSELLENGTH, 0, 0)
               IF n THEN
                  SendMessage hEdit, %EDM_COPY, 0, 0
                  SendMessage hEdit, %EDM_DELETE, 0, 0
               END IF
            CASE %IDM_Copy, %IDC_TBcopy
               SendMessage hEdit, %EDM_COPY, 0, 0
            CASE %IDM_Paste, %IDC_TBpaste
               SendMessage hEdit, %EDM_PASTE, 0, 0
            CASE %IDM_SelUcase
               SendMessage hEdit, %EDM_UCASE, 0, -1
            CASE %IDM_SelLcase
               SendMessage hEdit, %EDM_LCASE, 0, -1
            CASE %IDM_SelMcase
               SendMessage hEdit, %EDM_MCASE, 0, -1
            CASE %IDM_SelTcase
               SendMessage hEdit, %EDM_TCASE, 0, -1
            CASE %IDM_Comment 'comment selected lines
               n = SendMessage(hEdit, %EDM_GETSELLENGTH, 0, 0)
               IF n THEN SendMessage hEdit, %EDM_COMMENT, 0, 0
            CASE %IDM_unComment 'uncomment selected lines
               n = SendMessage(hEdit, %EDM_GETSELLENGTH, 0, 0)
               IF n THEN SendMessage hEdit, %EDM_COMMENT, 0, 1
            CASE %IDM_Tab 'tab selected lines
               n = SendMessage(hEdit, %EDM_GETSELLENGTH, 0, 0)
               IF n THEN SendMessage hEdit, %EDM_COMMENT, 0, 2
            CASE %IDM_unTab 'untab selected lines
               n = SendMessage(hEdit, %EDM_GETSELLENGTH, 0, 0)
               IF n THEN SendMessage hEdit, %EDM_COMMENT, 0, 3
            CASE %IDM_MoveTabRight
               clickedTab = thisTab
               DIALOG SEND CB.HNDL, %WM_COMMAND, %IDM_MoveRight, 0
            CASE %IDM_MoveTabLeft
               clickedTab = thisTab
               DIALOG SEND CB.HNDL, %WM_COMMAND, %IDM_MoveLeft, 0
            CASE %IDM_Syntax  'toggle syntax coloring on/off
               n = SendMessage(hEdit, %EDM_GETSYNTAXONOFF, 0, 0)
               SendMessage hEdit, %EDM_SETSYNTAXONOFF, 1-n, 0
            CASE %IDM_GridLines  'toggle grid lines on/off
               n = SendMessage(hEdit, %EDM_GETGRID, 0, 0)
               SendMessage hEdit, %EDM_SETGRID, 1-n, 0
            CASE %IDM_Find, %IDC_TBfind
               myFindReplace
            CASE %IDM_FindNext  'F3
               myFindReplace 3
            CASE %IDM_FindPrev   'shft+F3
               myFindReplace -3
            CASE %IDM_Replace, %IDC_TBfindRepl
               myFindReplace 1
            CASE %IDM_GotoLine
               s = myInput(hEdit, "     Line number: ", "Goto Line", "")
               n = VAL(s)
               SendMessage hEdit, %EDM_GOTOLINE, n, 0
               SendMessage hEdit, %EDM_SETTOPLINE, n, 1
               updateStatus
            CASE %IDC_TBsubfcn  'codeFinder from toolbar
               mayGotoSub = 0
               codeFinder
               updateStatus
            CASE %IDM_CodeFinder  'F4
               mayGotoSub = 1
               savedTop = SendMessage(hEdit, %EDM_GETTOPLINE, 0, 0)
               savedLine = SendMessage(hEdit, %EDM_GETSELSTARTY, 0, 0)
               savedPos = SendMessage(hEdit, %EDM_GETSELSTARTX, 0, 0)
               savedTxtPos = SendMessage(hEdit, %EDM_GETSELPOSSTART, 0, 0)
               codeFinder
               updateStatus
            CASE %IDM_CodeFindRtn  'shft+F4
               SendMessage hEdit, %EDM_SETCARETY, savedLine, 0
               SendMessage hEdit, %EDM_SETCARETX, savedPos, 0
               SendMessage hEdit, %EDM_SETTOPLINE, savedTop, 1
               SendMessage hEdit, %EDM_SETSELPOSSTART, savedTxtPos, 0
               updateStatus
            CASE %IDM_SetBkMk
               SendMessage hEdit, %EDM_SETBMARK, 0, 0
            CASE %IDM_NextBkMk
               SendMessage hEdit, %EDM_NEXTBMARK, 0, 0
            CASE %IDM_PrevBkMk
               SendMessage hEdit, %EDM_PREVBMARK, 0, 0
            CASE %IDM_ClrBkMks
               SendMessage hEdit, %EDM_RESETBMARKSALL, 0, 0
            CASE %IDM_Compile, %IDC_TBcompile
               edmCompile(1)
            CASE %IDM_CompileRun, %IDC_TBcompRun
               edmCompile(0)
            CASE %IDM_Options
               options                  
            CASE %IDM_EdtHelp
               'HtmlHelp CB.HNDL, edtHelp, 0, 0
               'pidHelp = SHELL("hh.exe " + edtHelp)
               appHelp edtHelp, "myPBEditor Help", hDlg
            CASE %IDM_PBhelp, %IDC_TBhelp
               IF pbVer = 8 THEN
                  winHelp CBHNDL, pbHelp, %HELP_CONTENTS, 0
               ELSE
                  'HtmlHelp CB.HNDL, pbHelp, 0, 0
                  pidHelp = SHELL("hh.exe " + pbHelp)
               END IF
            CASE %IDM_SDKhelp
               winHelp CB.HNDL, SDKhelp, 15, 0
            CASE %IDM_About
               about
            CASE %IDM_MoveRight
               IF clickedTab < numTabs THEN moveTab(1)
            CASE %IDM_MoveLeft           
               IF clickedTab > 1 THEN moveTab(-1)
         END SELECT
      CASE %WM_DESTROY
         killProcess pidRun
         IF pbVer = 8 THEN
            winHelp CBHNDL, pbHelp, %HELP_QUIT, 0
         ELSE                                                                                        
            killProcess pidHelp
         END IF                                         
      CASE %WM_SYSCOMMAND
         IF CB.CTL = %SC_CLOSE then  'AND &HFFF0 THEN 
            'prompt to save files that have changed ---------------------------------
            FOR i = 1 TO numTabs
               changed = SendMessage(edmHandles(i), %EDM_GETCHANGED, 0, 0)
               IF changed THEN
                  n = SendMessage(edmHandles(i), %EDM_GETTEXTLEN, 0, 0)
                  t = "Exiting Program "                                                                          
                  s = PATHNAME$(NAMEX, fileNames(i)) + $CRLF + $CRLF _
                    + "This file has changed... do you want to save it"
                  n = MSGBOX(s, %MB_ICONQUESTION OR %MB_YESNOCANCEL, t)
                  IF n = %IDCANCEL THEN FUNCTION = 1: CLOSE #fileNo: EXIT FUNCTION
                  IF n = %IDNO THEN ITERATE
                  saveFiles i
               END IF                   
            NEXT i                                      
            IF subsequentInst THEN                                                         
               'ensure that iniFile is saved for first instance only
               DIALOG END CB.HNDL: EXIT FUNCTION
            END IF                                               
            saveIniFile: DIALOG END CB.HNDL                                                                                    
         END IF
      CASE ELSE
   END SELECT
END FUNCTION

SUB saveIniFile()
   LOCAL fileNo, i, x, y AS LONG
   DIALOG GET LOC hDlg TO x, y
   x = MAX(x, 0): y = MAX(y, 0)
   fileNo = FREEFILE
   OPEN iniFile FOR OUTPUT AS #fileNo
   WRITE #fileNo, oneInst, beepOpt, compMsg, backups, numBackups, lastSub
   WRITE #fileNo, pbVer, TBsize, fontSize, lineSpac, tabSpaces
   WRITE #fileNo, x, y, wi, ht, numTabs
   WRITE #fileNo, backupPath
   WRITE #fileNo, PB8Path
   WRITE #fileNo, PB9Path
   WRITE #fileNo, PB10Path
   WRITE #fileNo, pbPath                                  
   WRITE #fileNo, rcCompiler
   WRITE #fileNo, pbCompiler
   WRITE #fileNo, sdkHelp
   WRITE #fileNo, pbHelp
   WRITE #fileNo, inclPath
   WRITE #fileNo, confine, wrapCaret, syntax, keywordCase, gridLines
   FOR i = 1 TO numTabs
      WRITE #fileNo, fileNames(i)
   NEXT i
   CLOSE #fileNo
END SUB

SUB openIniFile()
   LOCAL fileNo, i AS LONG
   fileNo = FREEFILE
   OPEN iniFile FOR INPUT LOCK READ AS #fileNo
   INPUT #fileNo, oneInst, beepOpt, compMsg, backups, numBackups, lastSub
   INPUT #fileNo, pbVer, TBsize, fontSize, lineSpac, tabSpaces
   INPUT #fileNo, x, y, wi, ht, numFiles
   INPUT #fileNo, backupPath
   INPUT #fileNo, PB8Path
   INPUT #fileNo, PB9Path
   INPUT #fileNo, PB10Path
   INPUT #fileNo, pbPath
   INPUT #fileNo, rcCompiler
   INPUT #fileNo, pbCompiler
   INPUT #fileNo, sdkHelp
   INPUT #fileNo, pbHelp
   INPUT #fileNo, inclPath
   INPUT #fileNo, confine, wrapCaret, syntax, keywordCase, gridLines
   REDIM inputFiles(1 to numFiles) AS STRING
   FOR i = 1 TO numFiles
      INPUT #fileNo, inputFiles(i)
   NEXT i
   CLOSE #fileNo
END SUB

FUNCTION subClassTabProc(BYVAL hWnd&, BYVAL wMsg&, BYVAL wParm&, BYVAL lParm&) AS LONG
   LOCAL pt AS POINTAPI                                                                    
   LOCAL tc AS TC_HITTESTINFO
   SELECT CASE wMsg&
      CASE %WM_RBUTTONDOWN 'show floating tab menu
         pt.x = LOWRD(lParm&): pt.y = HIWRD(lParm&)
         tc.pt = pt
         clickedTab = SendMessage(hTab, %TCM_HITTEST, 0, VARPTR(tc)) + 1   'zero based
         thisTab = clickedTab
         TAB SELECT hDlg, %IDC_Tab, thisTab
         hEdit = edmHandles(thisTab)
         IF pageLoaded(thisTab) = 0 THEN
            edmSetText hEdit, fileText(thisTab)
            pageLoaded(thisTab) = 1
         END IF
         SetFocus hEdit
         updateStatus
         ClientToScreen hWnd&, pt
         TrackPopupMenuEx hMouseTabMenu, 0, pt.x, pt.y, hDlg, BYVAL %NULL
   END SELECT
   FUNCTION = CallWindowProc(gOrigTabProc, hWnd&, wMsg&, wParm&, lParm&)
END FUNCTION

FUNCTION subClassEditProc(BYVAL hWnd&, BYVAL wMsg&, BYVAL wParm&, BYVAL lParm&) AS LONG
   LOCAL x, y, charHeight, topLine AS LONG
   LOCAL pt AS POINTAPI                                                                            
   SELECT CASE wMsg&
      CASE %WM_KEYUP 'Process navigation keybd messages and update status bar
         IF (GetKeyState(%VK_CONTROL) AND &H8000) and wParm& = %VK_DOWN THEN
            'column block selection... if I ever get to it
            'just four long values are necessary to specify block selection
            'first, get selBlockFirst, selBlockLeft, and selBlockRight from beginning line
            'then increment selBlockLast for each call here
            'finally, code block delete, copy, cut, and paste 
            selBlockFirst = 0
            selBlockLast = 0
            selBlockLeft = 0
            selBlockRight = 0
         else
            SELECT CASE wParm&
            CASE %VK_UP, %VK_DOWN, %VK_LEFT, %VK_RIGHT, %VK_HOME, %VK_END, %VK_PRIOR, %VK_NEXT, _
                 %VK_BACK, %VK_RETURN, %VK_TAB, %VK_SPACE
               subFcnRange = -1: updateStatus
               FUNCTION = 1: EXIT FUNCTION
            CASE %VK_ESCAPE
               subFcnRange = -1
            END SELECT
         end if
      CASE %WM_LBUTTONUP
         subFcnRange = -1: updateStatus
      CASE %WM_RBUTTONDOWN  'show floating edit menu (right clicking mouse)
         pt.x = LOWRD(lParm&): pt.y = HIWRD(lParm&)
         charHeight = SendMessage(hWnd&, %EDM_GETCHARHEIGHT, 0, 0)
         topLine = SendMessage(hWnd&, %EDM_GETTOPLINE, 0, 0)
         y = pt.y\charHeight + topLine
         SendMessage hWnd&, %EDM_SETCARETX, 0, 0
         SendMessage hWnd&, %EDM_SETCARETY, y, 0
         ClientToScreen hWnd&, pt
         TrackPopupMenuEx hMouseEdtMenu, 0, pt.x, pt.y, hDlg, BYVAL %NULL
   END SELECT
   IF subFcnRange < 0 THEN subFcnRange = 0: getBounds
   ' Pass the message on to the original window procedure
   FUNCTION = CallWindowProc(gOrigEditProc, hWnd&, wMsg&, wParm&, lParm&)
END FUNCTION

SUB addFile(f AS STRING)                                                                                             
   LOCAL nstyle, hFont, i AS LONG
   LOCAL s AS STRING
   FOR i = 1 TO numTabs
      IF f = fileNames(i) THEN
         s = PATHNAME$(NAMEX, f): gErr = 1
         MSGBOX "File already loaded", %MB_ICONERROR, s: EXIT SUB
      END IF
   NEXT i
   INCR numTabs 
   REDIM PRESERVE pageHandles(numTabs)
   REDIM PRESERVE fileNames(numTabs)
   REDIM PRESERVE fileText(numTabs)
   REDIM PRESERVE edmHandles(numTabs)
   REDIM PRESERVE pageLoaded(numTabs)
   s = UCASE$(PATHNAME$(EXTN, f))
   IF s = ".BAS" OR s = ".INC" THEN colorKeywords = 1
   s = PATHNAME$(NAMEX, f)
   TAB INSERT PAGE hDlg, %IDC_Tab, numTabs, 0, s, CALL tabDlgProc TO hPage
   pageHandles(numTabs) = hPage
   fileNames(numTabs) = f
   nStyle = %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %WS_VSCROLL OR %WS_HSCROLL OR %ES_NOHIDESEL
   hEdit = CreateEdm32edit(hPage, %IDC_Tab + numTabs, 0, 0, wi-10, ht-100, nStyle, 0, 0)  'create edm textbox
   edmHandles(numTabs) = hEdit
   hFont = edmSetFontEditor(hEdit, "Courier New", fontSize, 0, 0, 0)
   SendMessage hEdit, %WM_SETFONT, hFont, 1000*VAL(lineSpac)
   displayLines = SendMessage(hEdit, %EDM_LINESPERWINDOW, 0, 0)
   SendMessage hEdit, %EDM_SETBMCOLOR, RGB(0,255,255), 0   'set new bookmark color (default is red)
   SendMessage hEdit, %EDM_SETKBSHORTCUTS, %TRUE, 0        'tell control to use internal keyboard shortcuts
   SendMessage hEdit, %EDM_SETTABSIZE, tabSpaces, 0        'set tab spaces
   SendMessage hEdit, %EDM_CONFINECARET, confine, 0        'set whether to confine caret to line length
   SendMessage hEdit, %EDM_WRAPCARETLINE, wrapCaret, 0     'set whether to wrap caret at line ends to next/prev line
   SendMessage hEdit, %EDM_SETSYNTAXONOFF, syntax, 0       'set syntax coloring on/off
   SendMessage hEdit, %EDM_SETKWCASE, keywordCase, 0       'set keywords to [0]ignore, [1]UCASE, [2]Mixed, [3]lcase
   SendMessage hEdit, %EDM_SETGRID, gridLines, 0           'set grid lines on/off
   TAB SELECT hDlg, %IDC_Tab, numTabs
   getFileText(numTabs)
   thisTab = numTabs
   thisFile = fileNames(thisTab)
   IF numTabs = 1 THEN
      FOR i = 1 TO 17   'enable toolbar buttons
         TOOLBAR SET STATE hDlg, %IDC_Toolbar, i, %TBSTATE_ENABLED
      NEXT i
      setMenuState(1)
   END IF
   'subclass EDM textbox for detecting navigation keys and mouse clicks
   gOrigEditProc = SetWindowLong(hEdit, %GWL_WNDPROC, CODEPTR(subClassEditProc))
END SUB

CALLBACK FUNCTION tabDlgProc()
   SELECT CASE CBMSG
      CASE %WM_SIZE
         TAB GET SELECT hDlg, %IDC_Tab TO thisTab
         IF thisTab THEN
            hPage = pageHandles(thisTab)
            CONTROL SET SIZE hPage, %IDC_Tab + thisTab, wi-10, ht-100
         END IF
      CASE %WM_COMMAND
   END SELECT
END FUNCTION

SUB addMenu()
   LOCAL hSelBlock, hSelCase, hHelpMenu AS LONG
   MENU NEW BAR TO hMenu
   MENU NEW POPUP TO hFileMenu
   MENU ADD POPUP, hMenu, "&File", hFileMenu, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "&New File" + $TAB + "Ctrl+N", %IDM_New, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "&Open File" + $TAB + "Ctrl+O", %IDM_Open, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "&Save File" + $TAB + "Ctrl+S", %IDM_Save, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "Save File As", %IDM_SaveAs, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "Save &All Files", %IDM_SaveAll, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "Save As Project", %IDM_SaveProj, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "-", 0, 0
   MENU ADD STRING, hFileMenu, "&Print" + $TAB + "Ctrl+P", %IDM_Print, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "&Close File", %IDM_Close, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "Close &All Files", %IDM_CloseAll, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "E&xit" + $TAB + "Alt+F4", %IDM_Exit, %MF_ENABLED

   MENU NEW POPUP TO hEditMenu
   MENU ADD POPUP, hMenu, "&Edit", hEditMenu, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&Undo" + $TAB + "Ctrl+Z", %IDM_Undo, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&Delete", %IDM_Delete, %MF_ENABLED
   'MENU ADD STRING, hEditMenu, "&Clear", %IDM_Clear, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "-", 0, 0
   MENU ADD STRING, hEditMenu, "&Select All" + $TAB + "Ctrl+A", %IDM_SelectAll, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&Select Line" + $TAB + "Ctrl+L", %IDM_SelectLine, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "-", 0, 0
   MENU ADD STRING, hEditMenu, "&Cut" + $TAB + "Ctrl+X", %IDM_Cut, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&Copy" + $TAB + "Ctrl+C", %IDM_Copy, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&Paste" + $TAB + "Ctrl+V", %IDM_Paste, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "-", 0, 0

   MENU NEW POPUP TO hSelCase  'case sub menu
   MENU ADD POPUP, hEditMenu, "&Selected Case", hSelCase, %MF_ENABLED
   MENU ADD STRING, hSelCase, "&Upper Case" + $TAB + "Ctrl+U", %IDM_SelUcase, %MF_ENABLED
   MENU ADD STRING, hSelCase, "&Lower Case" + $TAB + "Ctrl+L", %IDM_SelLcase, %MF_ENABLED
   MENU ADD STRING, hSelCase, "&Mixed Case" + $TAB + "Ctrl+M", %IDM_SelMcase, %MF_ENABLED
   MENU ADD STRING, hSelCase, "&Reversed Case" + $TAB + "Ctrl+T", %IDM_SelTcase, %MF_ENABLED

   MENU NEW POPUP TO hSelBlock  'block sub menu
   MENU ADD POPUP, hEditMenu, "&Selected Block", hSelBlock, %MF_ENABLED
   MENU ADD STRING, hSelBlock, "Comment" + $TAB + "Ctrl+Q", %IDM_Comment, %MF_ENABLED
   MENU ADD STRING, hSelBlock, "unComment" + $TAB + "Shft+Ctrl+Q", %IDM_unComment, %MF_ENABLED
   MENU ADD STRING, hSelBlock, "-", 0, 0
   MENU ADD STRING, hSelBlock, "Tab Indent" + $TAB + "Tab", %IDM_Tab, %MF_ENABLED
   MENU ADD STRING, hSelBlock, "Tab unIndent" + $TAB + "Shft+Tab", %IDM_unTab, %MF_ENABLED
   MENU ADD STRING, hSelBlock, "-", 0, 0

   MENU NEW POPUP TO hViewMenu
   MENU ADD POPUP, hMenu, "&View", hViewMenu, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "Move Tab Right", %IDM_MoveTabRight, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "Move Tab Left", %IDM_MoveTabLeft, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "-", 0, 0
   MENU ADD STRING, hViewMenu, "&Toggle Syntax Coloring" + $TAB + "Ctrl+H", %IDM_Syntax, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "&Toggle Grid Lines" + $TAB + "Ctrl+G", %IDM_GridLines, %MF_ENABLED


   MENU NEW POPUP TO hSrchMenu
   MENU ADD POPUP, hMenu, "&Search", hSrchMenu, %MF_ENABLED
   MENU ADD STRING, hSrchMenu, "&Find" + $TAB + "Ctrl+F", %IDM_Find, %MF_ENABLED
   MENU ADD STRING, hSrchMenu, "&Find Next" + $TAB + "F3", %IDM_FindNext, %MF_ENABLED
   MENU ADD STRING, hSrchMenu, "&Find Prev" + $TAB + "Shft+F3", %IDM_FindPrev, %MF_ENABLED
   MENU ADD STRING, hSrchMenu, "&Replace" + $TAB + "Ctrl+R", %IDM_Replace, %MF_ENABLED
   MENU ADD STRING, hSrchMenu, "-", 0, 0
   MENU ADD STRING, hSrchMenu, "&Goto Line", %IDM_GotoLine,%MF_ENABLED
   MENU ADD STRING, hSrchMenu, "&Code Finder" + $TAB + "F4", %IDM_CodeFinder, %MF_ENABLED
   MENU ADD STRING, hSrchMenu, "&Code Finder Rtn" + $TAB + "Shft+F4", %IDM_CodeFindRtn, %MF_ENABLED
   MENU ADD STRING, hSrchMenu, "-", 0, 0
   MENU ADD STRING, hSrchMenu, "&Set Bookmark" + $TAB + "F2", %IDM_SetBkMk, %MF_ENABLED
   MENU ADD STRING, hSrchMenu, "&Next Bookmark" + $TAB + "Ctrl+F2", %IDM_NextBkMk, %MF_ENABLED
   MENU ADD STRING, hSrchMenu, "&Prev Bookmark" + $TAB + "Shft+F2", %IDM_PrevBkMk, %MF_ENABLED
   MENU ADD STRING, hSrchMenu, "&Clear Bookmarks" + $TAB + "Shft+Ctrl+F2", %IDM_ClrBkMks, %MF_ENABLED

   MENU NEW POPUP TO hRunMenu
   MENU ADD POPUP, hMenu, "&Run", hRunMenu, %MF_ENABLED
   MENU ADD STRING, hRunMenu, "&Compile" + $TAB + "F11", %IDM_Compile, %MF_ENABLED
   MENU ADD STRING, hRunMenu, "&Compile and Run" + $TAB + "F12", %IDM_CompileRun, %MF_ENABLED
   MENU ADD STRING, hRunMenu, "-", 0, 0
   MENU ADD STRING, hRunMenu, "&Options", %IDM_Options, %MF_ENABLED

   MENU NEW POPUP TO hHelpMenu
   MENU ADD POPUP, hMenu, "&Help", hHelpMenu, %MF_ENABLED
   MENU ADD STRING, hHelpMenu, "my PB&Editor Help", %IDM_EdtHelp, %MF_ENABLED
   MENU ADD STRING, hHelpMenu, "PB &Compiler Help", %IDM_PBhelp, %MF_ENABLED
   MENU ADD STRING, hHelpMenu, "&Windows SDK Help", %IDM_SDKhelp, %MF_ENABLED
   MENU ADD STRING, hHelpMenu, "-", 0, 0
   MENU ADD STRING, hHelpMenu, "&About PBEditor", %IDM_About, %MF_ENABLED

   MENU ATTACH hMenu, hDlg

   'floating menus - right click mouse
   MENU NEW POPUP TO hMouseEdtMenu 'floating edit menu -------------------------
   MENU ADD STRING, hMouseEdtMenu, "Select This Line", %IDM_SelectLine, %MF_ENABLED
   MENU ADD STRING, hMouseEdtMenu, "Delete Selected Lines", %IDM_Delete, %MF_ENABLED
   MENU ADD STRING, hMouseEdtMenu, "-", 0, 0
   MENU ADD STRING, hMouseEdtMenu, "Comment Selected Lines", %IDM_Comment, %MF_ENABLED
   MENU ADD STRING, hMouseEdtMenu, "unComment Selected Lines", %IDM_unComment, %MF_ENABLED
   MENU ADD STRING, hMouseEdtMenu, "Set Bookmark", %IDM_SetBkmk, %MF_ENABLED

   MENU NEW POPUP TO hMouseTabMenu 'floating tab menu --------------------------
   MENU ADD STRING, hMouseTabMenu, "Move Tab Right", %IDM_MoveRight, %MF_ENABLED
   MENU ADD STRING, hMouseTabMenu, "Move Tab Left", %IDM_MoveLeft, %MF_ENABLED
   MENU ADD STRING, hMouseTabMenu, "-", 0, 0
   MENU ADD STRING, hMouseTabMenu, "Close File", %IDM_CloseTab, %MF_ENABLED
   MENU ADD STRING, hMouseTabMenu, "Close All Files", %IDM_CloseAll, %MF_ENABLED

   setMenuState(0)
END SUB

SUB setMenuState(nOpt AS LONG)
   LOCAL n, i AS LONG
   IF nOpt THEN n = %MFS_ENABLED ELSE n = %MFS_DISABLED   '%MFS_GRAYED
   FOR i = 3 TO 9
      MENU SET STATE hFileMenu, i, n
   NEXT i
   FOR i = 1 TO 9
      MENU SET STATE hEditMenu, i, n
   NEXT i
   FOR i = 1 TO 5
      MENU SET STATE hViewMenu, i, n
   NEXT i
   FOR i = 1 TO 14
      MENU SET STATE hSrchMenu, i, n
   NEXT i
   FOR i = 1 TO 3
      MENU SET STATE hRunMenu, i, n
   NEXT i
END SUB

SUB addToolbar()
   LOCAL nStyle AS LONG

   'add a toolbar to the dialog box
   nStyle = %TBSTYLE_FLAT OR %TBSTYLE_TOOLTIPS OR %CCS_TOP
   CONTROL ADD TOOLBAR, hDlg, %IDC_Toolbar, "", 0, 0, 0, 0, nStyle
   CONTROL SET COLOR hDlg, %IDC_Toolbar, -1, -2

   ' Add the buttons to the toolbar
   TOOLBAR ADD BUTTON hDlg, %IDC_Toolbar, 1, %IDC_TBnew, %TBSTYLE_BUTTON, ""
   TOOLBAR ADD BUTTON hDlg, %IDC_Toolbar, 2, %IDC_TBopen, %TBSTYLE_BUTTON, ""
   TOOLBAR ADD BUTTON hDlg, %IDC_Toolbar, 3, %IDC_TBsave, %TBSTYLE_BUTTON, ""              
   TOOLBAR ADD BUTTON hDlg, %IDC_Toolbar, 4, %IDC_TBprint, %TBSTYLE_BUTTON, ""
   TOOLBAR ADD SEPARATOR hDlg, %IDC_Toolbar, 18
   TOOLBAR ADD BUTTON hDlg, %IDC_Toolbar, 5, %IDC_TBcut, %TBSTYLE_BUTTON, ""
   TOOLBAR ADD BUTTON hDlg, %IDC_Toolbar, 6, %IDC_TBcopy, %TBSTYLE_BUTTON, ""
   TOOLBAR ADD BUTTON hDlg, %IDC_Toolbar, 7, %IDC_TBpaste, %TBSTYLE_BUTTON, ""
   TOOLBAR ADD SEPARATOR hDlg, %IDC_Toolbar, 18
   TOOLBAR ADD BUTTON hDlg, %IDC_Toolbar, 8, %IDC_TBfind, %TBSTYLE_BUTTON, ""
   TOOLBAR ADD BUTTON hDlg, %IDC_Toolbar, 9, %IDC_TBfindRepl, %TBSTYLE_BUTTON, ""
   TOOLBAR ADD BUTTON hDlg, %IDC_Toolbar, 10, %IDC_TBsubFcn, %TBSTYLE_BUTTON, ""
   TOOLBAR ADD SEPARATOR hDlg, %IDC_Toolbar, 18
   TOOLBAR ADD BUTTON hDlg, %IDC_Toolbar, 11, %IDC_TBcompile, %TBSTYLE_BUTTON, ""
   TOOLBAR ADD BUTTON hDlg, %IDC_Toolbar, 12, %IDC_TBcompRun, %TBSTYLE_BUTTON, ""
   TOOLBAR ADD SEPARATOR hDlg, %IDC_Toolbar, 18
   TOOLBAR ADD BUTTON hDlg, %IDC_Toolbar, 13, %IDC_TBhelp, %TBSTYLE_BUTTON, ""
   setImageList
END SUB

SUB setImageList
   IMAGELIST KILL hImageList
   IF TBsize = 16 THEN  '16x16 icons
      IMAGELIST NEW ICON 16, 16, 8, 13 TO hImageList
      IMAGELIST ADD ICON hImageList, "Inew16"            'new button
      IMAGELIST ADD ICON hImageList, "Iopen16"           'open button
      IMAGELIST ADD ICON hImageList, "Isave16"           'save button
      IMAGELIST ADD ICON hImageList, "Iprint16"          'print button
      IMAGELIST ADD ICON hImageList, "Icut16"            'cut button
      IMAGELIST ADD ICON hImageList, "Icopy16"           'copy button
      IMAGELIST ADD ICON hImageList, "Ipaste16"          'paste button
      IMAGELIST ADD ICON hImageList, "Ifind16"           'find button
      IMAGELIST ADD ICON hImageList, "IfindRepl16"       'find & replace button
      IMAGELIST ADD ICON hImageList, "IsubFcn16"         'subs & functions
      IMAGELIST ADD ICON hImageList, "Icompile16"        'compile
      IMAGELIST ADD ICON hImageList, "IcompRun16"        'compile & run
      IMAGELIST ADD ICON hImageList, "Ihelp16"           'PowerBasic help
   ELSE '24x24 icons
      IMAGELIST NEW ICON 24, 24, 8, 4 TO hImageList
      IMAGELIST ADD ICON hImageList, "Inew24"            'new button
      IMAGELIST ADD ICON hImageList, "Iopen24"           'open button
      IMAGELIST ADD ICON hImageList, "Isave24"           'save button
      IMAGELIST ADD ICON hImageList, "Iprint24"          'print button       
      IMAGELIST ADD ICON hImageList, "Icut24"            'cut button
      IMAGELIST ADD ICON hImageList, "Icopy24"           'copy button
      IMAGELIST ADD ICON hImageList, "Ipaste24"          'paste button
      IMAGELIST ADD ICON hImageList, "Ifind24"           'find button
      IMAGELIST ADD ICON hImageList, "IfindRepl24"       'find & replace button
      IMAGELIST ADD ICON hImageList, "IsubFcn24"         'subs & functions
      IMAGELIST ADD ICON hImageList, "Icompile24"        'compile
      IMAGELIST ADD ICON hImageList, "IcompRun24"        'compile & run
      IMAGELIST ADD ICON hImageList, "Ihelp24"           'PowerBasic help
   END IF
   'set the toolbars normal button images
   TOOLBAR SET IMAGELIST hDlg, %IDC_TOOLBAR, hImageList, 0
   CONTROL SET LOC hDlg, %IDC_TBline, 0, 12+TBsize
END SUB

SUB addKeybdAccels()
   'add keyboard accelerators
   LOCAL hAccel AS LONG
   REDIM ac(1 TO 17) AS ACCELAPI

   ac(1).fvirt = %FVIRTKEY OR %FCONTROL               'Ctrl+N
   ac(1).key = %VK_N
   ac(1).cmd =  %IDM_New

   ac(2).fvirt = %FVIRTKEY OR %FCONTROL               'Ctrl+O
   ac(2).key = %VK_O
   ac(2).cmd =  %IDM_Open

   ac(3).fvirt = %FVIRTKEY OR %FCONTROL               'Ctrl+S
   ac(3).key = %VK_S
   ac(3).cmd =  %IDM_Save

   ac(4).fvirt = %FVIRTKEY OR %FCONTROL               'Ctrl+P
   ac(4).key = %VK_P
   ac(4).cmd =  %IDM_Print

   ac(5).fvirt = %FVIRTKEY OR %FCONTROL               'Ctrl+L
   ac(5).key = %VK_L
   ac(5).cmd =  %IDM_SelectLine

   ac(6).fvirt = %FVIRTKEY OR %FCONTROL               'Ctrl+F
   ac(6).key = %VK_F
   ac(6).cmd =  %IDM_Find

   ac(7).fvirt = %FVIRTKEY OR %FCONTROL               'Ctrl+R
   ac(7).key = %VK_R
   ac(7).cmd =  %IDM_Replace

   ac(8).fvirt = %FVIRTKEY                            'F3
   ac(8).key = %VK_F3
   ac(8).cmd =  %IDM_FindNext

   ac(9).fvirt = %FVIRTKEY OR %FSHIFT                 'Shft+F3
   ac(9).key = %VK_F3
   ac(9).cmd =  %IDM_FindPrev

   ac(10).fvirt = %FVIRTKEY                           'F1
   ac(10).key = %VK_F1
   ac(10).cmd =  %IDM_PBHelp

   ac(11).fvirt = %FVIRTKEY                           'F4
   ac(11).key = %VK_F4
   ac(11).cmd =  %IDM_CodeFinder

   ac(12).fvirt = %FVIRTKEY OR %FSHIFT                'Shft+F4
   ac(12).key = %VK_F4
   ac(12).cmd =  %IDM_CodeFindRtn

   ac(13).fvirt = %FVIRTKEY                           'F11
   ac(13).key = %VK_F11
   ac(13).cmd =  %IDM_Compile

   ac(14).fvirt = %FVIRTKEY                           'F12
   ac(14).key = %VK_F12
   ac(14).cmd =  %IDM_CompileRun

   ac(15).fvirt = %FVIRTKEY OR %FCONTROL              'Ctrl+Q
   ac(15).key = %VK_Q
   ac(15).cmd =  %IDM_Comment

   ac(16).fvirt = %FVIRTKEY OR %FCONTROL OR %FSHIFT   'Ctrl+Shft+Q
   ac(16).key = %VK_Q
   ac(16).cmd =  %IDM_unComment

   ac(17).fvirt = %FVIRTKEY OR %FSHIFT OR %FCONTROL   'Shft+Ctrl+F2
   ac(17).key = %VK_F2
   ac(17).cmd =  %IDM_ClrBkMks

   ACCEL ATTACH hDlg, ac() TO hAccel
END SUB

SUB updateStatus()
   LOCAL i, j, m, n, hFont AS LONG
   LOCAL s, ss, sLine, sWord, sLast AS STRING
   dim words(2) as string
   FONT NEW "MS Sans Serif", 8 TO hFont
   control set font hDlg, %IDC_Status, hFont
   IF numTabs = 0 THEN
      STATUSBAR SET TEXT hDlg, %IDC_Status, 1, 0, ""
      STATUSBAR SET TEXT hDlg, %IDC_Status, 2, 0, ""
      STATUSBAR SET TEXT hDlg, %IDC_Status, 3, 0, ""
      EXIT SUB
   END IF
   'show the file name in the first part ----------------------------------------
   s = fitLongFileName(hDlg, thisFile, wi - 255)
   STATUSBAR SET TEXT hDlg, %IDC_Status, 1, 0, s  'thisFile
   'show the sub or function that the cursor is in ------------------------------
   i = SendMessage(hEdit, %EDM_GETCARETY, 0, 0) + 2  'line number
   sWord = "": m = i  'save first i
   DO 'scan file upward for containing proc (ss used for ucase)
      'This algorithm assumes that FUNCTION, SUB, METHOD, PROPERTY blocks are left aligned,
      'and that the first and last statements are not split with a continue underscore.
      
      if i < m then j = 1 
      DECR i
      sLine = edmTxtGetLine(hEdit, i - 1)
      ss = UCASE$(trim$(sLine))
      sWord = ""
      IF LEFT$(ss, 4) = "END " THEN
         ss = TRIM$(MID$(ss, 4)) + " "
         IF (left$(ss, 9) = "FUNCTION " OR left$(ss, 4) = "SUB " _
            or left$(ss, 7) = "METHOD " OR left$(ss, 9) = "PROPERTY ") then
               IF j then sWord = "": exit do   'outside of all procs
         end if
         iterate
      ELSEIF LEFT$(ss, 9) = "FUNCTION " THEN
         ss = lTRIM$(MID$(ss, 9))
         if left$(ss, 1) = "=" then iterate
      ELSEIF LEFT$(ss, 9) = "CALLBACK "THEN
         ss = lTRIM$(MID$(ss, 9))
         if left$(ss, 9) = "FUNCTION " THEN
            ss = ltrim$(mid$(ss, 9))
            if left$(ss, 1) = "=" then iterate
         end if
      ELSEIF LEFT$(ss, 4) = "SUB " THEN
         ss = TRIM$(MID$(ss, 5))
      ELSEIF instr(ss, "METHOD ") THEN
         n = instr(ss, "METHOD ")
         if n then 
            ss = trim$(left$(ss, n-1))
            if ss <> "CLASS" AND ss <> "OVERRIDE" THEN ITERATE
         END IF
         s = mid$(ss, n + 7)
         if left$(ss, 1) = "=" then iterate
      ELSEIF instr(ss, "PROPERTY ") THEN
         n = instr(ss, "PROPERTY ")    
         if n then 
            ss = trim$(left$(ss, n-1))
            if ss <> "OVERRIDE" THEN ITERATE
         END IF
         ss = mid$(ss, n + 9)
         if left$(ss, 1) = "=" then iterate
         if LEFT$(ss, 4) = "GET " then iterate 
         if LEFT$(ss, 4) = "SET " then iterate 
      ELSEIF LEFT$(ss, 7) = "THREAD " THEN
         ss = lTRIM$(MID$(sLine, 7))
         if left$(ss, 9) = "FUNCTION " THEN
            ss = TRIM$(MID$(ss, 9))
            if left$(ss, 1) = "=" then iterate  
         end if
      else
         iterate
      END IF
      sWord = trim$(PARSE$(ss, ANY " :(", 1))
      n = instr(ucase$(sLine), sWord)
      sWord = mid$(sLine, n, n + len(sWord))
   LOOP UNTIL LEN(sWord) OR i <= 1
   n = instr(sWord, "("): if n then sWord = left$(sWord, n-1)
   STATUSBAR SET TEXT hDlg, %IDC_Status, 2, 0, "   " + sWord
   'show the line and column of the cursor --------------------------------------
   n = SendMessage(hEdit, %EDM_GETCARETY, 0, 0) + 1  'line no
   m = SendMessage(hEdit, %EDM_GETCARETX, 0, 0) + 1  'column no
   STATUSBAR SET TEXT hDlg, %IDC_Status, 3, 0, "    " + FORMAT$(n, "0000") + " : " + FORMAT$(m, "000")
END SUB

FUNCTION fitLongFileName(h AS LONG, s AS STRING, w AS LONG) AS STRING
   'fit long path name in space of w pixels with balanced info about middle
   'filename must always show, then the first part, then the rest is added
   '  h - handle to window with s
   '  s - string to fit
   '  w - width in pixels
   '--------------------------------------------------------------------------
   LOCAL hfont, i, j, k, m, n AS LONG
   LOCAL f, f1, f2, ff AS STRING
   LOCAL pt AS POINTAPI
   STATIC hdc, hLast AS LONG

   IF h <> hLast THEN hdc = GetDC(h): hLast = h  'minimize calls to GetDC
   DIALOG SEND h, %WM_GETFONT, 0, 0 TO hFont
   SelectObject(hdc, hFont)
   GetTextExtentPoint32 hdc, BYVAL STRPTR(s), BYVAL LEN(s), pt
   IF pt.x <= w THEN FUNCTION = s: EXIT FUNCTION
   f = PATHNAME$(NAMEX, s)
   f1 = PARSE$(s, "\", 1): f2 = f
   ff = f1 + "\...\" + f2
   GetTextExtentPoint32 hdc, BYVAL STRPTR(ff), BYVAL LEN(ff), pt
   IF pt.x < w THEN
      f = ff: n = pt.x
      k = (PARSECOUNT(s, "\")) - 2
      DIM nParts(k) AS LONG
      DIM sParts(k) AS STRING
      FOR i = 1 TO k  'get lenght of inside parts
         ff = PARSE$(s, "\", i + 1): sParts(i) = ff: ff = ff + "\"
         GetTextExtentPoint32 hdc, BYVAL STRPTR(ff), BYVAL LEN(ff), pt
         nParts(i) = pt.x
      NEXT i
      i = 1: j = k
      DO WHILE i < j
         IF (i+j) MOD 2 THEN m = i ELSE m = j
         IF n + nParts(m) > w THEN 'try other choice
            IF m = i THEN m = j ELSE m = i
            IF n + nParts(m) > w THEN EXIT DO
         END IF
         n = n + nParts(m)
         IF m = i THEN
            f = f1 + "\" + sParts(i) + "\...\" + f2
            f1 = f1 + "\" + sParts(i): INCR i
         ELSE
            f = f1 + "\...\" + sParts(j) + "\" + f2
            f2 = sParts(j) + "\" + f2: : DECR j
         END IF
      LOOP
   END IF
   FUNCTION = f
END FUNCTION

FUNCTION codeFinder() AS LONG
   LOCAL hCode, nStyle, w, h AS LONG                      
   LOCAL ti AS STRING
   ti = "Code Finder": w = 520: h = .70*ht
   DIALOG NEW PIXELS, hDlg, ti, wi/2, 50, w, h, %WS_SYSMENU TO hCode
   nStyle = %LBS_SORT OR %WS_VSCROLL OR %LBS_USETABSTOPS
   CONTROL ADD LISTBOX, hCode, %IDC_SubFcnList, , 0, 0, w, h - 50, nStyle
   CONTROL ADD BUTTON, hCode, %IDOK, "&GoTo", w - 150, h - 50, 60, 40
   CONTROL ADD BUTTON, hCode, %IDCANCEL, "&Cancel", w - 85, h - 50, 60, 40
   DIALOG SHOW MODAL hCode CALL codeFinderProc
END FUNCTION

CALLBACK FUNCTION codeFinderProc()                                           
   LOCAL n, i, numList, hFont, nLine, hiLite AS LONG
   LOCAL lptr AS LONG PTR                                                           
   LOCAL s, ss, sList, sLine, sType AS STRING
   STATIC hList, subLines() AS LONG
   STATIC subNames() AS STRING
   SELECT CASE AS LONG CB.MSG
      CASE %WM_INITDIALOG
         n = SendMessage(hEdit, %EDM_GETSELPOSSTART, 0, 0)
         SendMessage hEdit, %EDM_SETSEL, n, n  'put cursor at start of selection
         s = LCASE$(getProc)  'get word that cursor is on
         DIM tabstops(1 TO 2) AS LONG
         tabstops(1) = 5      'proc name
         tabstops(2) = -250   'proc type
         lptr = VARPTR(tabstops(1))
         CONTROL SEND CB.HNDL, %IDC_subFcnList, %LB_SETTABSTOPS, 2, lptr
         FONT NEW "Courier New", 10 TO hFont
         CONTROL SET FONT CB.HNDL, %IDC_SubFcnList, hFont
         hList = GetDlgItem(CB.HNDL, %IDC_SubFcnList)
         edmGetSubs hEdit, 0, hList
         LISTBOX DELETE CB.HNDL, %IDC_SUBFcnList, 1  '... get rid of top line: (Declarations)
         LISTBOX GET COUNT CB.HNDL, %IDC_SubFcnList TO numList
         REDIM subLines(numList)                                                                      
         REDIM subNames(numList)
         FOR i = 1 TO numList 'will set listbox to desired format
            'edm32 loaded the list with line numbers using %LB_SETITEMDATA
            nLine = SendMessage(hList, %LB_GETITEMDATA, i-1, 0)
            LISTBOX GET TEXT CB.HNDL, %IDC_SubFcnList, i TO sList
            subLines(i) = nLine: subNames(i) = sList
            IF (LCASE$(sList) = s) AND mayGotoSub THEN 'go directly to sub
               SendMessage hEdit, %EDM_GOTOLINE, nLine, 1
               SendMessage hEdit, %EDM_SETTOPLINE, nLine, 1
               DIALOG END CB.HNDL: EXIT FUNCTION
            ELSEIF (LCASE$(sList) = s) THEN 'hiLite the list item
               hiLite = i
            END IF
            sLine = LTRIM$(edmTxtGetLine(hEdit, nLine-1))
            n = INSTR(sLine, sList)
            sType = TRIM$(LEFT$(sLine, n - 1))
            LISTBOX SET TEXT CB.HNDL, %IDC_SubFcnList, i, sList + $TAB + sType
         NEXT i
         IF hiLite = 0 THEN hiLite = lastSub
         LISTBOX SELECT CB.HNDL, %IDC_SubFcnList, hiLite
         lastSub = hiLite
      CASE %WM_COMMAND
         SELECT CASE CB.CTL
            CASE %IDC_SubFcnList
               IF CB.CTLMSG = %LBN_DBLCLK THEN
                  DIALOG SEND CB.HNDL, %WM_COMMAND, %IDOK, 0
               END IF
            CASE %IDOK
               LISTBOX GET SELECT CB.HNDL, %IDC_SubFcnList TO n
               SendMessage hEdit, %EDM_GOTOLINE, subLines(n), 1
               lastSub = n
               n = SendMessage(hEdit, %EDM_GETCARETY, 0, 0)
               SendMessage hEdit, %EDM_SETTOPLINE, n, 1
               DIALOG END CB.HNDL
               updateStatus
            CASE %IDCANCEL
               DIALOG END CB.HNDL
         END SELECT
   END SELECT
END FUNCTION

'FUNCTION getWord() AS STRING
'   'get word that caret is on
'   LOCAL x, y, m AS LONG, ch AS BYTE
'   LOCAL sLine, s AS STRING                           
'   x = SendMessage(hEdit, %EDM_GETCARETX, 0, 0)
'   y = SendMessage(hEdit, %EDM_GETCARETY, 0, 0)
'   sLine = edmTxtGetLine(hEdit, y)
'   ch = ASC(MID$(sLine, x+1, 1))
'   'run to the right until a non-alphaNumeric char
'   DO UNTIL ISFALSE(IscharAlphaNumeric(ch)) and ch <> asc("-") and ch <> asc("_")
'      s = s + CHR$(ch): INCR m
'      IF x + m >= LEN(sLine) THEN EXIT DO
'      ch = ASC(MID$(sLine, x + m + 1, 1))           
'   LOOP
'   m = 1: ch = ASC(MID$(sLine, x-m+1, 1))
'   'now run to the left until a non-alphaNumeric char
'   DO UNTIL ISFALSE(IscharAlphaNumeric(ch)) and ch <> asc("-") and ch <> asc("_")
'      s = CHR$(ch) + s: INCR m
'      IF x-m < 0 THEN EXIT DO
'      ch = ASC(MID$(sLine, x-m+1, 1))
'   LOOP
'   FUNCTION = s
'END FUNCTION  

FUNCTION getProc() AS STRING
   'get proc name that caret is on
   LOCAL x, y, m, n AS LONG
   LOCAL sLine AS STRING
   x = SendMessage(hEdit, %EDM_GETCARETX, 0, 0)
   y = SendMessage(hEdit, %EDM_GETCARETY, 0, 0)
   sLine = edmTxtGetLine(hEdit, y)
   n = instr(x, sLine, any " :,)(") - 1
   if n <= 0 then n = len(sLine)
   sLine = left$(sLine, n)
   m = instr(-1, sLine, any " .(") + 1
   function = mid$(sLine, m)
END FUNCTION


SUB options()
   LOCAL hOpt, w, h AS LONG
   LOCAL ti AS STRING
   ti = "Options": w = 400: h = 450
   DIALOG NEW PIXELS, hDlg, ti, , , w, h, %WS_SYSMENU TO hOpt
   CONTROL ADD OPTION, hOpt, %IDC_PB8, "PB8", 10, 15, 45, 15, %WS_GROUP OR %WS_TABSTOP
   CONTROL ADD OPTION, hOpt, %IDC_PB9, "PB9", 10, 40, 45, 15
   CONTROL ADD OPTION, hOpt, %IDC_PB10, "PB10", 10, 65, 45, 15
   CONTROL ADD LABEL, hOpt, -1, "PB8 Path:", 72, 16, 60, 15, %WS_GROUP OR %WS_TABSTOP
   CONTROL ADD TEXTBOX, hOpt, %IDC_PB8Path, "", 130, 14, 200, 20
   CONTROL ADD BUTTON, hOpt, %IDC_PB8Btn, "...", 335, 14, 25, 20
   CONTROL ADD LABEL, hOpt, -1, "PB9 Path:", 72, 41, 60, 15
   CONTROL ADD TEXTBOX, hOpt, %IDC_PB9Path, "", 130, 39, 200, 20
   CONTROL ADD BUTTON, hOpt, %IDC_PB9Btn, "...", 335, 39, 25, 20
   CONTROL ADD LABEL, hOpt, -1, "PB10 Path:", 72, 66, 60, 15                                                    
   CONTROL ADD TEXTBOX, hOpt, %IDC_PB10Path, "", 130, 64, 200, 20
   CONTROL ADD BUTTON, hOpt, %IDC_PB10Btn, "...", 335, 64, 25, 20

   CONTROL ADD LABEL, hOpt, -1, "Font size:", 10, 121, 60, 15
   CONTROL ADD COMBOBOX, hOpt, %IDC_Fontsize,, 80, 119, 60, 15, %CBS_DROPDOWNLIST OR %WS_TABSTOP
   CONTROL ADD LABEL, hOpt, -1, "Line spacing:", 10, 151, 70, 15
   CONTROL ADD COMBOBOX, hOpt, %IDC_LineSpac,, 80, 149, 60, 15, %CBS_DROPDOWNLIST OR %WS_TABSTOP
   CONTROL ADD LABEL, hOpt, -1, "Tab spaces:", 10, 181, 60, 15
   CONTROL ADD COMBOBOX, hOpt, %IDC_Tabspaces,, 80, 179, 60, 15, %CBS_DROPDOWNLIST OR %WS_TABSTOP
   CONTROL ADD LABEL, hOpt, -1, "Toolbar size:", 10, 211, 60, 15
   CONTROL ADD COMBOBOX, hOpt, %IDC_TBsize,, 80, 209, 60, 15, %CBS_DROPDOWNLIST OR %WS_TABSTOP
   CONTROL ADD CHECKBOX, hOpt, %IDC_OneInst, "Allow only one instance", 200, 105, 180, 15, %WS_GROUP OR %WS_TABSTOP
   CONTROL ADD CHECKBOX, hOpt, %IDC_beepOpt, "Beep on successful compile", 200, 135, 180, 15
   CONTROL ADD CHECKBOX, hOpt, %IDC_CompMsg, "Compiler messages on success", 200, 165, 180, 15
   CONTROL ADD CHECKBOX, hOpt, %IDC_Confine, "Confine caret to line length", 200, 195, 180, 15
   CONTROL ADD CHECKBOX, hOpt, %IDC_WrapCaret, "Wrap caret at line ends", 200, 225, 180, 15
   CONTROL ADD CHECKBOX, hOpt, %IDC_syntax, "Syntax coloring... Ctrl+H", 200, 265, 180, 15
   CONTROL ADD CHECKBOX, hOpt, %IDC_gridLines, "show grid lines... Ctrl+G", 200, 295, 180, 15
   CONTROL ADD FRAME, hOpt, -1, "Keywords", 5, 252, 180, 65
   CONTROL ADD OPTION, hOpt, %IDC_KWignore, "Ignore case", 10, 270, 75, 15, %WS_GROUP OR %WS_TABSTOP
   CONTROL ADD OPTION, hOpt, %IDC_KWucase, "Upper case", 100, 270, 75, 15
   CONTROL ADD OPTION, hOpt, %IDC_KWmixed, "Mixed case", 10, 290, 75, 15
   CONTROL ADD OPTION, hOpt, %IDC_KWlcase, "Lower case", 100, 290, 75, 15
   CONTROL ADD CHECKBOX, hOpt, %IDC_Backups, "Keep backups", 10, 340, 100, 15, %WS_GROUP OR %WS_TABSTOP
   CONTROL ADD LABEL, hOpt, -1, "Backups numbered to:", 130, 341, 110, 15
   CONTROL ADD TEXTBOX, hOpt, %IDC_NumBackups, "1", 240, 339, 40, 20
   CONTROL ADD LABEL, hOpt, -1, "(99 max)", 285, 341, 40, 15
   CONTROL ADD LABEL, hOpt, -1, "Backup sub folder:", 10, 371, 90, 15
   CONTROL ADD TEXTBOX, hOpt, %IDC_BackupPath, "", 105, 369, 250, 20

   CONTROL ADD BUTTON, hOpt, %IDC_Reset, "&Reset", w - 185, h - 45, 60, 40, %WS_GROUP
   CONTROL ADD BUTTON, hOpt, %IDOK, "&Ok", w - 125, h - 45, 60, 40, %WS_GROUP
   CONTROL ADD BUTTON, hOpt, %IDCANCEL, "&Cancel", w - 65, h - 45, 60, 40
   DIALOG SHOW MODAL hOpt CALL optionsProc
END SUB

CALLBACK FUNCTION optionsProc()
   LOCAL i, m, n, hFont AS LONG
   LOCAL s AS STRING
   STATIC pbVerSav AS LONG
   SELECT CASE CB.MSG
      CASE %WM_INITDIALOG
         pbVerSav = pbVer
         n = %IDC_PB8 + pbVer - 8
         CONTROL SET OPTION CB.HNDL, n, %IDC_PB8, %IDC_PB10
         IF LEN(PB8Path) = 0 THEN PB8Path = "c:\pbWin80"
         IF LEN(PB9Path) = 0 THEN PB9Path = "c:\pbWin90"
         IF LEN(PB10Path) = 0 THEN PB10Path = "c:\pbWin10"
         CONTROL SET TEXT CB.HNDL, %IDC_PB8Path, PB8Path
         CONTROL SET TEXT CB.HNDL, %IDC_PB9Path, PB9Path
         CONTROL SET TEXT CB.HNDL, %IDC_PB10Path, PB10Path
         CONTROL ENABLE CB.HNDL, %IDC_PB8
         CONTROL ENABLE CB.HNDL, %IDC_PB9
         CONTROL ENABLE CB.HNDL, %IDC_PB10
         IF ISFALSE(ISFILE(PB8Path+"\bin\PBWin.exe")) THEN CONTROL DISABLE CB.HNDL, %IDC_PB8
         IF ISFALSE(ISFILE(PB9Path+"\bin\PBWin.exe")) THEN CONTROL DISABLE CB.HNDL, %IDC_PB9
         IF ISFALSE(ISFILE(PB10Path+"\bin\PBWin.exe")) THEN CONTROL DISABLE CB.HNDL, %IDC_PB10
         FOR i = 8 TO 16
            COMBOBOX ADD CB.HNDL, %IDC_Fontsize, STR$(i)
         NEXT i
         COMBOBOX SELECT CB.HNDL, %IDC_Fontsize, IIF(fontSize, fontSize-7, 3)
         COMBOBOX ADD CB.HNDL, %IDC_LineSpac, "1.000"
         COMBOBOX ADD CB.HNDL, %IDC_LineSpac, "1.025"
         COMBOBOX ADD CB.HNDL, %IDC_LineSpac, "1.050"
         COMBOBOX ADD CB.HNDL, %IDC_LineSpac, "1.075"
         COMBOBOX ADD CB.HNDL, %IDC_LineSpac, "1.100"
         COMBOBOX ADD CB.HNDL, %IDC_LineSpac, "1.125"
         COMBOBOX ADD CB.HNDL, %IDC_LineSpac, "1.250"
         COMBOBOX ADD CB.HNDL, %IDC_LineSpac, "1.500"
         COMBOBOX ADD CB.HNDL, %IDC_LineSpac, "2.000"                                                            
         COMBOBOX FIND EXACT CB.HNDL, %IDC_LineSpac, 1, lineSpac TO n
         COMBOBOX SELECT CB.HNDL, %IDC_LineSpac, IIF(n, n, 1)
         FOR i = 1 TO 8
            COMBOBOX ADD CB.HNDL, %IDC_Tabspaces, STR$(i)
         NEXT i
         COMBOBOX SELECT CB.HNDL, %IDC_Tabspaces, IIF(tabSpaces, tabSpaces, 3)
         COMBOBOX ADD CB.HNDL, %IDC_TBsize, "16 x 16"
         COMBOBOX ADD CB.HNDL, %IDC_TBsize, "24 x 24"
         IF TBsize = 16 THEN n = 1 ELSE n = 2
         COMBOBOX SELECT CB.HNDL, %IDC_TBsize, n
         CONTROL SET CHECK CB.HNDL, %IDC_OneInst, oneInst
         CONTROL SET CHECK CB.HNDL, %IDC_beepOpt, beepOpt
         CONTROL SET CHECK CB.HNDL, %IDC_CompMsg, compMsg
         CONTROL SET CHECK CB.HNDL, %IDC_Confine, confine
         CONTROL SET CHECK CB.HNDL, %IDC_WrapCaret, wrapCaret
         CONTROL SET CHECK CB.HNDL, %IDC_Syntax, syntax
         CONTROL SET CHECK CB.HNDL, %IDC_GridLines, gridLines
         CONTROL SET OPTION CB.HNDL, %IDC_KWignore + keywordCase, %IDC_KWignore, %IDC_KWlcase
         CONTROL SET CHECK CB.HNDL, %IDC_backups, backups
         CONTROL SET TEXT CB.HNDL, %IDC_NumBackups, STR$(MAX(numBackups, 1))
         CONTROL SET TEXT CB.HNDL, %IDC_BackupPath, backupPath
         IF LEN(backupPath) = 0 THEN 'default subfolder
            CONTROL SET TEXT CB.HNDL, %IDC_BackupPath, "Backups"
         END IF
         IF backups = 0 THEN
            CONTROL DISABLE CB.HNDL, %IDC_NumBackups
            CONTROL DISABLE CB.HNDL, %IDC_BackupPath
         END IF
      CASE %WM_COMMAND
         IF CB.CTL = %IDC_Reset AND CB.CTLMSG = %BN_CLICKED THEN
            CONTROL ENABLE CB.HNDL, %IDC_PB8
            CONTROL ENABLE CB.HNDL, %IDC_PB9
            CONTROL ENABLE CB.HNDL, %IDC_PB10
            s = "c:\pbWin80": IF ISFOLDER(s) THEN n = %IDC_PB8 _
                 ELSE s = "": CONTROL ENABLE CB.HNDL, %IDC_PB8
            CONTROL SET TEXT CB.HNDL, %IDC_PB8Path, s
            s = "c:\pbWin90": IF ISFOLDER(s) THEN n = %IDC_PB9 _
                 ELSE s = "": CONTROL ENABLE CB.HNDL, %IDC_PB9
            CONTROL SET TEXT CB.HNDL, %IDC_PB9Path, s
            s = "c:\pbWin10": IF ISFOLDER(s) THEN n = %IDC_PB10 _
                 ELSE s = "": CONTROL ENABLE CB.HNDL, %IDC_PB10
            CONTROL SET TEXT CB.HNDL, %IDC_PB10Path, s
            CONTROL SET OPTION CB.HNDL, n, %IDC_PB8, %IDC_PB10
            COMBOBOX SELECT CB.HNDL, %IDC_Fontsize, 3
            COMBOBOX SELECT CB.HNDL, %IDC_LineSpac, 1
            COMBOBOX SELECT CB.HNDL, %IDC_Tabspaces, 3
            COMBOBOX SELECT CB.HNDL, %IDC_TBsize, 2
            CONTROL SET CHECK CB.HNDL, %IDC_OneInst, 0
            CONTROL SET CHECK CB.HNDL, %IDC_beepOpt, 0
            CONTROL SET CHECK CB.HNDL, %IDC_CompMsg, 0
            CONTROL SET CHECK CB.HNDL, %IDC_Confine, 0
            CONTROL SET CHECK CB.HNDL, %IDC_WrapCaret, 0
            CONTROL SET CHECK CB.HNDL, %IDC_Syntax, 1
            CONTROL SET OPTION CB.HNDL, %IDC_KWignore + 1, %IDC_KWignore, %IDC_KWlcase
            CONTROL SET CHECK CB.HNDL, %IDC_Backups, 0
            CONTROL SET TEXT CB.HNDL, %IDC_numBackups, "8"
            CONTROL SET TEXT CB.HNDL, %IDC_BackupPath, "Backups"
         ELSEIF CB.CTL = %IDOK AND CB.CTLMSG = %BN_CLICKED THEN
            'accept these options and apply them
            CONTROL GET TEXT CB.HNDL, %IDC_PB8Path TO PB8Path
            CONTROL GET TEXT CB.HNDL, %IDC_PB9Path TO PB9Path
            CONTROL GET TEXT CB.HNDL, %IDC_PB10Path TO PB10Path
            CONTROL ENABLE CB.HNDL, %IDC_PB8
            CONTROL ENABLE CB.HNDL, %IDC_PB9
            CONTROL ENABLE CB.HNDL, %IDC_PB10
            IF ISFALSE(ISFOLDER(PB8Path)) THEN CONTROL DISABLE CB.HNDL, %IDC_PB8
            IF ISFALSE(ISFOLDER(PB9Path+"\bin")) THEN CONTROL DISABLE CB.HNDL, %IDC_PB9
            IF ISFALSE(ISFOLDER(PB10Path+"\bin")) THEN CONTROL DISABLE CB.HNDL, %IDC_PB10
            FOR i = 0 TO 2 'get PB version
               CONTROL GET CHECK CB.HNDL, %IDC_PB8+i TO n
               IF n = 1 THEN
                  PBver = 8+i: m = %IDC_PB8Path + i
                  CONTROL GET TEXT CB.HNDL, m TO pbPath: EXIT FOR
               END IF
            NEXT i
            rcCompiler = pbPath + "\bin\rc.exe"
            resConvert = pbPath + "\bin\pbRes.exe"
            pbCompiler = pbPath + "\bin\pbWin.exe"
            sdkHelp = pbPath + "\WinAPI\win32.hlp"
            pbHelp = pbPath + "\bin\pbWin.chm"
            IF PBver = 8 THEN pbHelp = pbPath + "\bin\pbWin.hlp"
            inclPath = pbPath + "\winAPI\"
            COMBOBOX GET SELECT CB.HNDL, %IDC_TBsize TO n
            IF n = 1 THEN m = 16 ELSE m = 24
            IF m <> TBsize THEN
               TBsize = m: setImageList
               CONTROL SET LOC hDlg, %IDC_TAB, 0, 16+TBsize
            END IF
            COMBOBOX GET SELECT CB.HNDL, %IDC_Fontsize TO n: fontSize = n + 7
            COMBOBOX GET TEXT CB.HNDL, %IDC_LineSpac TO lineSpac
            COMBOBOX GET SELECT CB.HNDL, %IDC_tabSpaces TO tabSpaces
            IF hEdit THEN
               hFont = edmSetFontEditor(hEdit, "Courier New", fontSize, 0, 0, 0)
               SendMessage hEdit, %WM_SETFONT, hFont, 1000*VAL(lineSpac)
               SendMessage hEdit, %EDM_SETTABSIZE, tabSpaces, 0
            END IF
            CONTROL GET CHECK CB.HNDL, %IDC_OneInst TO oneInst
            CONTROL GET CHECK CB.HNDL, %IDC_beepOpt TO beepOpt
            CONTROL GET CHECK CB.HNDL, %IDC_CompMsg TO compMsg
            CONTROL GET CHECK CB.HNDL, %IDC_Confine TO confine
            CONTROL GET CHECK CB.HNDL, %IDC_WrapCaret TO wrapCaret
            CONTROL GET CHECK CB.HNDL, %IDC_Syntax TO syntax
            CONTROL GET CHECK CB.HNDL, %IDC_GridLines TO gridLines
            FOR i = 0 TO 3
               CONTROL GET CHECK CB.HNDL, %IDC_KWignore + i TO n
               IF n THEN keywordCase = i: EXIT FOR
            NEXT i
            CONTROL GET CHECK CB.HNDL, %IDC_Backups TO backups
            CONTROL GET TEXT CB.HNDL, %IDC_NumBackups TO s: numBackups = VAL(s)
            CONTROL GET TEXT CB.HNDL, %IDC_BackupPath TO backupPath
            SendMessage hEdit, %EDM_CONFINECARET, confine, 0
            SendMessage hEdit, %EDM_WRAPCARETLINE, wrapCaret, 0
            SendMessage hEdit, %EDM_SETSYNTAXONOFF, syntax, 0
            SendMessage hEdit, %EDM_SETKWCASE, keywordCase, 0
            SendMessage hEdit, %EDM_SETGRID, gridLines, 0
            IF pbVer <> pbVerSav THEN
               IF pbVerSav = 8 THEN
                  winHelp hDlg, pbHelp, %HELP_QUIT, 0
               ELSE
                  killProcess pidHelp
               END IF
               loadKeywords
            END IF
            DIALOG END CB.HNDL
         ELSEIF CB.CTL = %IDCANCEL AND CB.CTLMSG = %BN_CLICKED THEN
            DIALOG END CB.HNDL
         ELSEIF CB.CTL = %IDC_PB8Btn AND CB.CTLMSG = %BN_CLICKED THEN
            DISPLAY BROWSE hDlg,,, "Specify Folder", "c:\", %BIF_NONEWFOLDERBUTTON  TO s
            CONTROL SET TEXT CB.HNDL, %IDC_PB8Path, s
         ELSEIF CB.CTL = %IDC_PB9Btn AND CB.CTLMSG = %BN_CLICKED THEN
            DISPLAY BROWSE hDlg,,, "Specify Folder", "c:\", %BIF_NONEWFOLDERBUTTON  TO s
            CONTROL SET TEXT CB.HNDL, %IDC_PB9Path, s
         ELSEIF CB.CTL = %IDC_PB10Btn AND CB.CTLMSG = %BN_CLICKED THEN
            DISPLAY BROWSE hDlg,,, "Specify Folder", "c:\", %BIF_NONEWFOLDERBUTTON  TO s
            CONTROL SET TEXT CB.HNDL, %IDC_PB10Path, s
         ELSEIF CB.CTL = %IDC_PB8Path AND CB.CTLMSG = %EN_CHANGE THEN
            CONTROL ENABLE CB.HNDL, %IDC_PB8
            CONTROL GET TEXT CB.HNDL, %IDC_PB8Path TO s
            IF ISFALSE(ISFILE(s+"\bin\PBWin.exe")) THEN CONTROL DISABLE CB.HNDL, %IDC_PB8
         ELSEIF CB.CTL = %IDC_PB9Path AND CB.CTLMSG = %EN_CHANGE THEN
            CONTROL ENABLE CB.HNDL, %IDC_PB9
            CONTROL GET TEXT CB.HNDL, %IDC_PB9Path TO s
            IF ISFALSE(ISFILE(s+"\bin\PBWin.exe")) THEN CONTROL DISABLE CB.HNDL, %IDC_PB9
         ELSEIF CB.CTL = %IDC_PB10Path AND CB.CTLMSG = %EN_CHANGE THEN
            CONTROL ENABLE CB.HNDL, %IDC_PB10
            CONTROL GET TEXT CB.HNDL, %IDC_PB10Path TO s
            IF ISFALSE(ISFILE(s+"\bin\PBWin.exe")) THEN CONTROL DISABLE CB.HNDL, %IDC_PB10
         ELSEIF CB.CTL = %IDC_backups THEN
            CONTROL GET CHECK CB.HNDL, %IDC_backups TO backups
            IF backups THEN
              CONTROL ENABLE CB.HNDL, %IDC_NumBackups
              CONTROL ENABLE CB.HNDL, %IDC_BackupPath
            ELSE
              CONTROL DISABLE CB.HNDL, %IDC_NumBackups
              CONTROL DISABLE CB.HNDL, %IDC_BackupPath
            END IF
         END IF
   END SELECT
END FUNCTION

SUB loadKeywords()
   'read PB keywords into an array named keywords()
   'from a file named pbxxKeys.txt of sorted, ucase keywords
   LOCAL i, numWords, fileNo AS LONG
   LOCAL keywordsFile, sFile AS STRING
   sFile = CHOOSE$(pbVer-7, "pb08keys.txt","pb09keys.txt","pb10keys.txt")
   keywordsFile = dataFolder + sFile
   numWords = CHOOSE&(pbVer-7, 757, 1949, 2294)
   ERASE keywords()
   REDIM keywords(1 TO numWords)
   IF ISFILE(keywordsFile) THEN
     fileNo = FREEFILE
     OPEN keywordsFile FOR INPUT AS #fileNo
     FOR i = 1 TO numWords   'read the data into the array
       INPUT #fileNo, keywords(i)
     NEXT
     CLOSE #fileNo
   END IF
   IF numTabs THEN SendMessage hEdit, %EDM_REFRESH, 0, -1
END SUB

SUB closeFile(nTab AS LONG)
   LOCAL i, j, k, n, changed AS LONG
   LOCAL s, t AS STRING
   DIM changes(numTabs) AS LONG
   IF numTabs = 0 THEN EXIT SUB
   FOR i = 1 TO numTabs
      changed = SendMessage(edmHandles(i), %EDM_GETCHANGED, 0, 0)
      changes(i) = changed
   NEXT i
   j = 1: k = numTabs
   IF nTab THEN j = nTab: k = nTab
   FOR i = k TO j STEP -1
      'changed = SendMessage(edmHandles(i), %EDM_GETCHANGED, 0, 0)
      IF changes(i) THEN
         t = PATHNAME$(NAMEX, fileNames(i))
         s = "Save this file?"
         n = MSGBOX(s, %MB_ICONQUESTION OR %MB_YESNOCANCEL, t)
         IF n = %IDCANCEL THEN EXIT FOR
         IF n = %IDYES THEN saveFiles i
      END IF
      DECR numTabs
      TAB DELETE hDlg, %IDC_Tab, i
      ARRAY DELETE fileNames(i)
      ARRAY DELETE pageHandles(i)
      ARRAY DELETE fileText(i)
      ARRAY DELETE edmHandles(i)
      ARRAY DELETE pageLoaded(i)
      ARRAY DELETE changes(i)
      IF numTabs THEN
         thisTab = MIN(i, numTabs): thisFile = fileNames(thisTab)
         hEdit = edmHandles(thisTab): thisFile = fileNames(thisTab)
         IF pageLoaded(thisTab) = 0 THEN
            edmSetText hEdit, fileText(thisTab)  'copy text into editor
         END IF
         pageLoaded(thisTab) = 1
         SendMessage(hEdit, %EM_SETSEL, 0, 0)
         TAB SELECT hDlg, %IDC_Tab, thisTab
      ELSE
         thisTab = 0: hEdit = 0
      END IF
   NEXT i
   IF numTabs THEN
      FOR i = 1 TO numTabs
         SendMessage edmHandles(i), %EDM_SETCHANGED, changes(i), 0
      NEXT i
   ELSE
      FOR i = 3 TO 15  'disable toolbar buttons
         TOOLBAR SET STATE hDlg, %IDC_Toolbar, i, %TBSTATE_DISABLED
      NEXT i
      setMenuState(0)
   END IF
END SUB

SUB getFileText(nTab AS LONG)
   LOCAL fileNo AS LONG
   LOCAL fn, sTxt AS STRING
   fileNo = FREEFILE
   fn = fileNames(nTab)
   OPEN fn FOR BINARY AS fileNo
   GET$ fileNo, LOF(fileNo), sTxt
   CLOSE fileNo
   fileText(nTab) = sTxt
END SUB

SUB openTheFile(f AS STRING)
   LOCAL fileNo AS LONG
   LOCAL s AS STRING
   IF PATHNAME$(EXTN, f) = ".pbj" THEN 'project file
      OPEN f FOR INPUT AS fileNo
      DO UNTIL EOF(fileNo)
         INPUT #fileNo, s: addFile s
      LOOP
      CLOSE #fileNo
      thisTab = 1: thisFile = fileNames(1)
      hEdit = edmHandles(1): pageLoaded(1) = 1
      edmSetText hEdit, fileText(1)  'copy in text for tab 1
      TAB SELECT hDlg, %IDC_Tab, 1
      SendMessage hEdit, %EDM_SETTOPLINE, 0, 1
      SendMessage hEdit, %EDM_SETSEL, 0, 0
   ELSE
      addFile f
      edmSetText hEdit, fileText(thisTab)  'copy text into editor
      pageLoaded(thisTab) = 1
   END IF
   SetFocus hEdit: updateStatus
END SUB

SUB saveFiles(nTab AS LONG)
   'nTab = 0, save all files
   'ntab > 0, save file on ntab
   '----------------------------------------------------------
   LOCAL i, j, k AS LONG
   LOCAL t AS STRING
   IF numTabs = 0 THEN EXIT SUB
   j = 1: k = numTabs: t = "Save File"
   IF nTab THEN j = nTab: k = nTab
   FOR i = k TO j STEP -1
      IF LCASE$(fileNames(i)) = LCASE$(dataFolder + "unNamed.bas") THEN
         saveAsFile i
      ELSE
         saveThisFile i
      END IF
   NEXT i
END SUB

SUB saveThisFile(nTab AS LONG)
   LOCAL hText, fileNo, n AS LONG
   LOCAL fn, s AS STRING
   fn = fileNames(nTab): hText = edmHandles(nTab)
   IF ISFILE(fn) THEN KILL fn
   n = SendMessage(hText, %EDM_GETTEXTLEN, 0, 0)
   s = SPACE$(n)
   SendMessage hText, %EDM_GETTEXT, STRPTR(s), n
   fileNo = FREEFILE
   OPEN fn FOR BINARY ACCESS WRITE AS fileNo
   PUT #fileNo,, s
   CLOSE fileNo
   fileText(nTab) = s
   SendMessage edmHandles(nTab), %EDM_SETCHANGED, 0, 0
END SUB

SUB saveAsFile(nTab AS LONG)
   LOCAL flags AS LONG
   LOCAL f, fn, ti, folder, filter AS STRING
   fn = PATHNAME$(NAMEX, fileNames(nTab))
   ti = "Save File": folder = chooseFolder()
   IF INSTR(3, folder, "program files") THEN folder = dataFolder
   flags = %OFN_OVERWRITEPROMPT OR %OFN_HIDEREADONLY OR %OFN_LONGNAMES
   filter = CHR$("Source (*.bas, *.inc)", 0, "*.bas; *.inc", 0, "All Files (*.*)", 0, "*.*", 0)
   DISPLAY SAVEFILE hDlg,,, ti, folder, filter, fn, "bas", flags TO f
   IF LEN(f) THEN
      thisFile = f: fileNames(thisTab) = f: updateStatus
      saveThisFile nTab
      TAB SET TEXT hDlg, %IDC_Tab, thisTab, TRIM$(PATHNAME$(NAMEX, f))
      CONTROL SEND hDlg, %IDC_Tab, %TCM_SETITEMSIZE, 0, MAK(DWORD, xTab-1, yTab) 'work around to center text
      CONTROL SEND hDlg, %IDC_Tab, %TCM_SETITEMSIZE, 0, MAK(DWORD, xTab, yTab)   'work around to center text
   END IF
END SUB

SUB saveAsProject()
   LOCAL hProj, ht, nFiles, flags, i AS LONG
   LOCAL ti, f, fn, folder, filter, s AS STRING
   ti = "Save File": 'folder = chooseFolder()
   IF INSTR(3, folder, "program files") THEN folder = dataFolder
   flags = %OFN_OVERWRITEPROMPT OR %OFN_HIDEREADONLY OR %OFN_LONGNAMES
   filter = CHR$("Project (*.pbj)", 0, "*.pbj", 0, "All Files (*.*)", 0, "*.*", 0)
   FOR i = 1 TO numTabs 'get default file and path
      IF LCASE$(PATHNAME$(EXTN, fileNames(i))) = ".bas" THEN
         fn = PATHNAME$(NAME, fileNames(i))
         folder = PATHNAME$(PATH, fileNames(i))
         EXIT FOR
      END IF
   NEXT i
   DISPLAY SAVEFILE hDlg,,, ti, folder, filter, fn, "pbj", flags TO f
   IF LEN(f) THEN
      ti = "Included Files in Project"
      nFiles = MIN(numTabs, 20)
      ht = 100 + 20 * nFiles
      DIALOG NEW PIXELS, 0, ti, , , 250, ht, %WS_SYSMENU TO hProj
      FOR i = 1 TO nFiles
         s = PATHNAME$(NAMEX, fileNames(i))
         CONTROL ADD CHECKBOX, hProj, %IDC_ProjFile + i, s, 20, 10 + 20*i, 250, 15
         CONTROL SET CHECK hProj, %IDC_ProjFile + i, 1
      NEXT i
      CONTROL ADD BUTTON, hProj, %IDOK, "&Ok", 150, ht - 50, 70, 30
      DIALOG SET USER hProj, 1, VARPTR(f)
      DIALOG SHOW MODAL hProj CALL projectProc
   END IF
END SUB

CALLBACK FUNCTION projectProc()
   LOCAL fileNo, n, i AS LONG
   LOCAL pf AS STRING PTR
   SELECT CASE CB.MSG
      CASE %WM_COMMAND
         IF CB.CTL = %IDOK AND CB.CTLMSG = %BN_CLICKED THEN
            fileNo = FREEFILE
            DIALOG GET USER CB.HNDL, 1 TO pf
            OPEN @pf FOR OUTPUT AS fileNo
            FOR i = 1 TO numTabs
               CONTROL GET CHECK CB.HNDL, %IDC_ProjFile + i TO n
               IF n THEN WRITE #fileNo, fileNames(i)
            NEXT i
            CLOSE #fileNo
            DIALOG END CB.HNDL
         ELSEIF CB.CTL = %IDCANCEL AND CB.CTLMSG = %BN_CLICKED THEN
            DIALOG END CB.HNDL
         END IF
   END SELECT
END FUNCTION

FUNCTION chooseFolder() AS STRING
   'choose folder of first BAS file, or of last non-Bas file
   LOCAL i, nbas, nOther AS LONG
   LOCAL s, f AS STRING
   FOR i = 1 TO numTabs
      s = LCASE$(PATHNAME$(EXTN, fileNames(i)))
      IF s = ".bas" THEN nbas = i ELSE nOther = i
   NEXT i
   IF nbas THEN
      f = PATHNAME$(PATH, fileNames(nbas))
   ELSEIF nOther THEN
      f = PATHNAME$(PATH, fileNames(nOther))
   ELSE
      f = CURDIR$
   END IF
   FUNCTION = LCASE$(f)
END FUNCTION

SUB printText()
   LOCAL hFont, hdc, xppi, yppi, numLines, selected, nFit AS LONG
   LOCAL nLine, pgLine, maxLines, nextPage, nPage, nFlag, m AS LONG
   LOCAL x00, y00, x, y, charWi, charHt, allowLen AS SINGLE
   LOCAL ti, s AS STRING, sz AS ASCIIZ*1024
   'local sz as WSTRINGZ *256
   LOCAL cSize AS SIZEL

   nLine = 1
   numLines = SendMessage(hEdit, %EDM_GETLINECOUNT, 0, 0)
   selected = SendMessage(hEdit, %EDM_GETSELLENGTH, 0, 0)
   IF selected THEN
      nLine = SendMessage(hEdit, %EDM_GETSELSTARTY, 0, 0) + 1
      numLines = SendMessage(hEdit, %EDM_GETSELENDY, 0, 0) + 1
      IF SendMessage(hEdit, %EDM_GETSELENDX, 0, 0) = 0 THEN DECR numLines
      nFlag = %PD_SELECTION
   END IF
   XPRINT ATTACH CHOOSE USING nFlag
   IF LEN(XPRINT$) = 0 THEN EXIT SUB
   FONT NEW "Courier New", 9 TO hFont
   XPRINT SET FONT hFont
   XPRINT GET DC TO hdc
   XPRINT GET PPI TO xppi, yppi
   XPRINT GET LINES TO m: maxLines = m - 2
   XPRINT GET MARGIN TO x00, y00, x, y
   XPRINT CHR SIZE TO charWi, charHt
   x = 0.75 * xppi - x00
   allowLen = 7.5 * xppi
   nFit = allowLen / charWi
   nextPage = 1: ti = PATHNAME$(NAMEX, thisFile)
   DO WHILE nLine <= numLines
      IF nextPage THEN
         INCR nPage
         XPRINT SET POS (x, charHt): XPRINT ti
         XPRINT SET POS (x + 6.75*xppi, charHt): XPRINT "Page"+STR$(nPage)
         XPRINT: XPRINT
         nextPage = 0: pgLine = 4
      END IF
      sz = getLineCase(edmTxtGetLine(hEdit, nLine - 1))
      GetTextExtentExPoint hdc, sz, SIZEOF(sz), allowLen, nFit, BYVAL 0, cSize
      s = LEFT$(getLineCase(sz), nFit)
      XPRINT SET POS (x, pgLine*charHt): XPRINT s
      sz = MID$(sz, nFit + 1)
      IF pgLine >= maxLines THEN nextPage = 1: XPRINT FORMFEED
      INCR pgLine
      INCR nLine
   LOOP
   XPRINT CLOSE
END SUB

FUNCTION getLineCase(BYVAL sTxt AS STRING) AS STRING
   'get line of text with chosen case (Ucase, Mcase, Lcase, Tcase)
   'wFlag, collecting characters for word
   'wPos, starting position of current word
   '--------------------------------------------------------------------------------
   LOCAL i, wFlag, wPos, found AS LONG
   LOCAL s, sWord AS STRING
   LOCAL letter AS BYTE PTR
   s = UCASE$(sTxt)
   letter = STRPTR(s): wFlag = 0: i = 0
   DO UNTIL i = LEN(s)
      INCR i
      SELECT CASE @letter
         CASE 39, 59  'comment for bas or asm code
            EXIT DO
         CASE  65 TO 90, 35 TO 38, 46, 48 TO 57, 63, 95
                 'A-Z     #,$,%,&  .      0-9    ?   _    'character to include in word
            IF wFlag = 0 THEN wFlag = 1 : wPos = i        'word starts here
         CASE ELSE 'word is ready
            IF wFlag THEN
               wFlag = 0
               sWord = MID$(s, wPos, i - wPos)
               found = binSrch(keywords(), sWord, 1, UBOUND(keywords))
               IF found THEN
                  found = 0
                  SELECT CASE keywordCase
                     CASE 0: sWord = MID$(sTxt, wPos, i - wPos)
                     CASE 1
                     CASE 2: edmMcase sWord
                     CASE 3: edmLcase sWord
                  END SELECT
                  MID$(sTxt, wPos, i - wPos) = sWord
               END IF
               IF LCASE$(sWord) = "rem" THEN EXIT DO
            END IF
      END SELECT
      INCR letter
   LOOP
   FUNCTION = sTxt
END FUNCTION

SUB edmCompile(compilerOpt AS LONG)
   'compilerOpt = 0  compile and run
   'compilerOpt = 1  compile only
   'compile the selected file if a bas/rc source file, otherwise first bas/rc file
   '--------------------------------------------------------------------------------------------
   LOCAL i, m, n, fileNo, nbas, nrc, nErr, nRow, nCol, result AS LONG
   LOCAL s, ss, sRC, f, ff, fPath, fn, basFile, logFile, exeFile, msg, errMsg AS STRING
   LOCAL files() AS STRING

   s = LCASE$(PATHNAME$(EXTN, thisFile))
   IF s = ".bas" THEN 'selected source file
      nbas = thisTab
   ELSEIF s = ".rc" THEN 'selected resource file
      nrc = thisTab
   ELSE 'assume primary source file as first tabbed bas file
      FOR i = 1 TO numTabs
         s = LCASE$(PATHNAME$(EXTN, fileNames(i)))
         IF nbas = 0 AND s = ".bas" THEN nbas = i
      NEXT i
   END IF
   'process the backup folder prior to compiling
   IF LEN(backupPath) THEN
      ss = PATHNAME$(PATH, fileNames(nbas)) + backupPath
      s = DIR$(ss + "\*.*", 0): n = 0
      DIM files(0)
      DO WHILE LEN(s)
         INCR n: REDIM PRESERVE files(n)                            
         files(n) = s: s = DIR$
      LOOP
      ARRAY SORT files()
      FOR i = 1 TO numTabs 'update the backup folder and save the files
         IF SendMessage(edmHandles(i), %EDM_GETCHANGED, 0, 0) THEN 'file changed
            saveFiles i: f = LCASE$(fileNames(i))
            IF f = LCASE$(dataFolder + "unNamed.bas") THEN ITERATE
            updateBackups ss, i, files()
         END IF
      NEXT i
   END IF

   'compile source and resource files
   ff = fileNames(nrc) 'resource file
   f = fileNames(nbas) 'source file
   fPath = PATHNAME$(PATH, ff)                         
   if len(fPath) then CHDIR fPath
   IF ISFILE(f) = 0 AND ISFILE(ff) = 0 THEN
      s = "Source or resource file not found"
      MSGBOX s, %MB_ICONERROR, "PB" + TRIM$(STR$(pbVer)) + "Error - Cannot Compile": EXIT SUB
   END IF
   IF ISFILE(ff) THEN 'compile resource file
      KILL PATHNAME$(PATH, ff) + PATHNAME$(NAME, ff) + ".res"
      KILL PATHNAME$(PATH, ff) + PATHNAME$(NAME, ff) + ".pbr"                       
      s = $DQ+rcCompiler+$DQ + " " + $DQ+ff+$DQ
      chdir pbPath + "\winapi\"  '... this is to make Resource.h visible
      n = ERRCLEAR: SHELL s: n = ERR
      ss = PATHNAME$(PATH, ff) + PATHNAME$(NAME, ff) + ".res"               
      s = $DQ+resConvert+$DQ + " " + $DQ+ss+$DQ
      m = ERRCLEAR: SHELL s: m = ERR
      IF n THEN MSGBOX ERROR$(n), %MB_ICONERROR, "Error creating RES file"
      IF m THEN MSGBOX ERROR$(m), %MB_ICONERROR, "Error creating PBR file"
      IF m OR n THEN EXIT SUB
      s = PATHNAME$(PATH, ff) + PATHNAME$(NAME, ff) + ".res"
      ss = PATHNAME$(PATH, ff) + PATHNAME$(NAME, ff) + ".pbr"
      s = s + $CRLF + ss + $CRLF + $CRLF + "... Created successfully" 
      's = ss + $CRLF + $CRLF + "... Created successfully"
      MSGBOX s, %MB_ICONINFORMATION, "Resource Files"
      TAB SELECT hDlg, %IDC_Tab, thisTab: EXIT SUB
   END IF                                                                                     
   IF ISFILE(f) THEN
      fPath = PATHNAME$(PATH, f)
      IF LEN(fPath) THEN CHDIR fPath
      basFile = PATHNAME$(NAMEX, f)
      exeFile = PATHNAME$(NAME, f) + ".exe": 
      if isfile(exeFile) then KILL exeFile
      logFile = PATHNAME$(NAME, f) + ".log": 
      if isfile(logFile) then KILL logFile
      's = $DQ+pbCompiler+$DQ + " " + $DQ+f+$DQ + " /I" + $DQ+inclPath+$DQ + ";" + $DQ+fPath+$DQ + " /L/Q "
      s = $DQ+pbCompiler+$DQ + " " + $DQ+f+$DQ + " /I" + $DQ+inclPath+$DQ + " /L/Q "
      n = ERRCLEAR
      SHELL s  'compile the source file
      n = ERR: IF n THEN MSGBOX ERROR$(n): EXIT SUB
      'shell process succeeded... now check results of compile
      'obtain the log file information for error analysis
      logFile = PATHNAME$(NAME, f) + ".log"
      exeFile = PATHNAME$(NAME, f) + ".exe"
      IF ISFILE(logFile) THEN
         'nerr defines compiler error
         'errMsg describes compiler error
         errMsg = ""
         fileNo = FREEFILE
         OPEN logFile FOR INPUT AS #fileNo
         WHILE ISFALSE EOF(fileNo)
            LINE INPUT# fileNo, s
            IF INSTR(s, "Component Files:") THEN EXIT LOOP
            errMsg = errMsg + s + $CRLF
            n = INSTR(s, "Error")
            IF n THEN
               m = INSTR(s, "in")
               nErr = VAL(MID$(s, n + 5, m - n + 5))
               s = LTRIM$(MID$(s, m + 2))
               fn = PARSE$(s, ANY "()", 1)
               fn = LCASE$(PATHNAME$(NAMEX, fn))
               s = PARSE$(s, ANY "()", 2)
               nRow = VAL(PARSE$(s, ":", 1))
               nCol = VAL(PARSE$(s, ":", 2))
            END IF
         WEND
         CLOSE fileNo
         'find which tab has file fn loaded
         n = thisTab
         FOR i = 1 TO numTabs 'find which tab
            ss = LCASE$(PATHNAME$(NAMEX, fileNames(i)))
            IF ss = fn THEN thisTab = i: EXIT FOR
         NEXT i
         IF n <> thisTab THEN
            TAB SELECT hDlg, %IDC_Tab, thisTab
            hEdit = GetDlgItem(pageHandles(thisTab), %IDC_Tab + thisTab)
            edmSetText hEdit, fileText(thisTab)  'copy text into editor
         END IF
         IF nErr THEN  'now, select where error has been detected
            SendMessage hEdit, %EDM_GOTOLINE, nRow, 1
            n = SendMessage(hEdit, %EDM_GETCARETPOS, 0, 0) - 1
            SendMessage hEdit, %EDM_SETSEL, n + nCol, n + nCol
            SendMessage hEdit, %EDM_REFRESH, 0, 1
            SendMessage hEdit, %EDM_SETTOPLINE, nRow, 1
         END IF
         IF nErr = 0 AND compilerOpt = 0 THEN KILL logFile
         IF nErr OR compilerOpt = 1 OR compMsg THEN
            IF compilerOpt = 1 AND beepOpt THEN BEEP
            s = "PowerBasic Compiler" + STR$(pbVer)
            IF nErr THEN s = s + " - Error Messages" ELSE s = s + " - Successful"
            MSGBOX LEFT$(errMsg, LEN(errMsg)-2),, s
            IF nErr OR compilerOpt = 1 THEN EXIT SUB
         END IF
      ELSE 'compiler error, no log file
         EXIT SUB
      END IF
   END IF
   IF compilerOpt THEN EXIT SUB 'just compiling, not running
   IF beepOpt THEN BEEP
   'and finally, run the executable file that is created by the compiler
   exeFile = $DQ + fPath + exeFile + $DQ
   result = ShellExecute(BYVAL %NULL, "open", exeFile+CHR$(0), BYVAL %NULL, BYVAL %NULL, %SW_SHOWNORMAL)
   IF result > 32 THEN EXIT SUB
   SELECT CASE result
   CASE 0                       : msg = "The operating system is out of memory or resources.
   CASE %ERROR_FILE_NOT_FOUND   : msg = "The specified file was not found.
   CASE %ERROR_PATH_NOT_FOUND   : msg = "The specified path was NOT found.
   CASE %ERROR_BAD_FORMAT       : msg = "The .exe file IS invalid (non-Win32 .exe OR ERROR IN .exe IMAGE).
   CASE %SE_ERR_ACCESSDENIED    : msg = "The operating system denied ACCESS TO the specified file.
   CASE %SE_ERR_ASSOCINCOMPLETE : msg = "The file NAME association IS incomplete OR invalid.
   CASE %SE_ERR_DDEBUSY         : msg = "The DDE transaction could NOT be completed because other DDE transactions were being processed.
   CASE %SE_ERR_DDEFAIL:        : msg = "The DDE transaction failed.
   CASE %SE_ERR_DDETIMEOUT      : msg = "The DDE transaction could NOT be completed because the request timed out.
   CASE %SE_ERR_DLLNOTFOUND     : msg = "The specified DLL was NOT found.
   CASE %SE_ERR_FNF             : msg = "The specified file was NOT found.
   CASE %SE_ERR_NOASSOC         : msg = "There IS no application associated WITH the given file NAME extension. This ERROR will also be returned IF you attempt TO PRINT a file that IS NOT printable.
   CASE %SE_ERR_OOM             : msg = "There was NOT enough memory TO complete the operation.
   CASE %SE_ERR_PNF             : msg = "The specified path was NOT found.                           
   CASE %SE_ERR_SHARE           : msg = "A sharing violation occurred.
   CASE ELSE                    : msg = "Unknown Shell message " + STR$(result)
   END SELECT
   msg = exeFile + $CRLF + $CRLF + msg
   MSGBOX msg, %MB_ICONERROR, "Error running executable file"
END SUB

SUB updateBackups(folder AS STRING, n AS LONG, files() AS STRING)
   'backup the file at nth tab
   LOCAL i, j, k, nFiles AS LONG
   LOCAL s, s1, s2, sName, sSrc, sDest AS STRING
   IF ISFALSE(ISFOLDER(folder)) THEN MKDIR folder
   sName = PATHNAME$(NAMEX, fileNames(n))
   nFiles = UBOUND(files)
   FOR i = nFiles TO 1 STEP -1
      s = files(i)
      j = INSTR(s, ".")
      s2 = MID$(s, j+1)
      IF s2 = sName THEN
         s1 = LEFT$(s, j-1): k = VAL(RIGHT$(s1, 2))
         sSrc = folder + "\Backup " + FORMAT$(k, "00") + "." + sName
         sDest = folder + "\Backup " + FORMAT$(k+1, "00") + "." + sName
         IF k < numBackups THEN NAME sSrc AS sDest ELSE KILL sSrc
      END IF
   NEXT i
   'now add file at nth tab to top of backup list
   sDest = folder + "\Backup 01." + sName
   FILECOPY fileNames(n), sDest
END SUB

FUNCTION SpecialFolder(pidl AS DWORD) AS STRING
' by Wayne Diamond 12-03-01
' http://www.powerbasic.com/support/forums/Forum7/HTML/001233.html
'----------------------------------------------------------------------
   LOCAL TmpAsciiz AS ASCIIZ * %MAX_PATH
   CoInitialize BYVAL 0
   IF ISFALSE(SHGetSpecialFolderLocation(BYVAL %HWND_DESKTOP, BYVAL pidl, BYVAL VARPTR(pidl))) THEN
      SHGetPathFromIDList BYVAL pidl, TmpAsciiz
      CoTaskMemFree BYVAL pidl
   END IF
   CoUninitialize
   FUNCTION = TmpAsciiz
END FUNCTION

SUB killProcess(procID AS DWORD)
   LOCAL hProcess AS DWORD
   hProcess = OpenProcess(%PROCESS_TERMINATE, %false, procID)
   IF hProcess THEN
      TerminateProcess hProcess, 0
      Closehandle hProcess
   END IF
END SUB

SUB createFolder(BYVAL folder AS STRING)
   LOCAL i, n AS LONG
   LOCAL f, s, sNet AS STRING
   IF LEFT$(folder, 2) = "\\" THEN 'UNC network path
      sNet = "\\": folder = MID$(folder, 3)
   END IF
   n = PARSECOUNT(folder, "\")
   FOR i = 1 TO n
      f = PARSE$(folder, "\", i)
      IF LEN(f) THEN
         s = s + f + "\"
         IF ISFOLDER(sNet + s) = 0 THEN MKDIR sNet + s
      END IF
   NEXT i
END SUB

FUNCTION myInput(OPT BYVAL hParent AS LONG, BYVAL prompt AS STRING, _
                     BYVAL ti AS STRING, BYVAL def AS STRING) AS STRING
   'def - default input string for sizing of textbox
   LOCAL hInput, hdc, nStyle, hFont, w, w1, w2, w3, x, y AS LONG
   LOCAL t AS SIZEL, myInputStr AS STRING
   LOCAL sz AS ASCIIZ * 256
   nStyle = %WS_CAPTION OR %WS_POPUP OR %WS_SYSMENU OR %DS_MODALFRAME OR %WS_SYSMENU
   DIALOG NEW PIXELS, hParent, ti, , , 0, 0, nStyle TO hInput
   hdc = GetDC(hInput)
   DIALOG SEND hInput, %WM_GETFONT, 0, 0 TO hFont
   SelectObject(hdc, hFont)
   sz = prompt: GetTextExtentPoint32 hDC, sz, LEN(sz), t: w1 = t.cx
   sz = def + SPACE$(2): GetTextExtentPoint32 hDC, sz, LEN(sz), t: w2 = MAX(t.cx, 80)
   sz = ti + SPACE$(2): GetTextExtentPoint32 hDC, sz, LEN(sz), t: w3 = MAX(t.cx, 120)
   ReleaseDC hInput, hdc
   w = MAX(w1 + w2, w3, 120)
   IF hParent THEN
      DIALOG GET CLIENT hParent TO x, y
   ELSE
      DESKTOP GET CLIENT TO x, y
   END IF
   x = x/2 - w/2: y = y/4
   DIALOG SET LOC hInput, x, y
   DIALOG SET SIZE hInput, w + 40, 120
   CONTROL ADD LABEL, hInput, -1, prompt, 5, 15, w1 + 5, 20
   CONTROL ADD TEXTBOX, hInput, 9999, def, w1 + 5, 15, w2 + 5, 20
   CONTROL ADD BUTTON, hInput, %IDOK, "Ok", w - 80, 50, 80, 30
   DIALOG SET USER hInput, 1, VARPTR(myInputStr)
   DIALOG SHOW MODAL hInput, CALL myInputProc
   FUNCTION = TRIM$(myInputStr)
END FUNCTION

CALLBACK FUNCTION myInputProc()
   LOCAL ps AS STRING PTR
   SELECT CASE CB.MSG
      CASE %WM_INITDIALOG
         CONTROL SET FOCUS CB.HNDL, 9999
      CASE %WM_COMMAND
         IF CBCTL = %IDOK OR CB.CTL = %IDCANCEL THEN
            DIALOG GET USER CB.HNDL, 1 TO ps
            CONTROL GET TEXT CB.HNDL, 9999 TO @ps
            DIALOG END CB.HNDL
         END IF
      CASE %WM_SYSCOMMAND
         IF CB.CTL = %SC_CLOSE THEN
            DIALOG SEND CB.HNDL, %WM_COMMAND, %IDCANCEL, 0
         END IF
   END SELECT
END FUNCTION

'--------------------------------------------------------------------------------------------------
'  Find and replace routines
'--------------------------------------------------------------------------------------------------
FUNCTION myFindNext(sFind AS STRING, whole AS LONG, ncase AS LONG, ndir AS LONG) AS LONG
   'this function finds and returns the next position of the search string
   'findTxt = string to be searched for
   'whole, ncase, ndir specifies search state to be used
   '-------------------------------------------------------------------------------------
   LOCAL k, nLen, nPos, nSel, cycled, done AS LONG

   nLen = SendMessage(hEdit, %EDM_GETSELLENGTH, 0, 0)
   IF nLen THEN 'selected text from previous search
      IF ndir THEN 'backward search
         k = SendMessage(hEdit, %EDM_GETSELPOSSTART, 0, 0) - 1
      ELSE 'forward search
         k = SendMessage(hEdit, %EDM_GETSELPOSEND, 0, 0) + 1
      END IF
   ELSE 'no selected text when beginning search, so start at cursor position
      k = SendMessage(hEdit, %EDM_GETCARETPOS, 0, 0)
   END IF
   SendMessage hEdit, %EDM_SETSEL, k, k
   nPos = -1
   DO 'find the next one
      nSel = edmTxtFindNext(hEdit, sFind, ndir, ncase, whole, 0)
      IF nSel = 0 THEN 'none found
         IF allFiles THEN 'switch to next tab
            srchNextTab(ndir)
            IF thisTab = saveThisTab THEN EXIT DO
            BEEP: ITERATE
         END IF
         IF ndir = 0 THEN  'forward searching
            IF nPos = startPos THEN nSel = 0: EXIT DO
            nPos = startPos: SendMessage hEdit, %EDM_SETSEL, nPos, nPos
            BEEP: ITERATE
         ELSE  'backward searching
            IF nPos = endPos THEN nSel = 0: EXIT DO
            nPos = endPos: SendMessage hEdit, %EDM_SETSEL, nPos, nPos
            BEEP: ITERATE
         END IF
      ELSEIF nSel > endPos THEN 'check if past sub/fcn end
         IF nPos = startPos THEN nSel = 0: EXIT DO
         nPos = startPos: SendMessage hEdit, %EDM_SETSEL, nPos, nPos
         BEEP: ITERATE
      ELSEIF nSel < startPos THEN 'check if past sub/fcn start
         IF nPos = endPos OR cycled THEN nSel = 0: EXIT DO
         nPos = endPos: SendMessage hEdit, %EDM_SETSEL, nPos, nPos
         BEEP: ITERATE
      END IF
      done = 1
   LOOP UNTIL done
   FUNCTION = nSel
END FUNCTION

FUNCTION myFindReplace(OPT BYVAL nOpt AS LONG) AS LONG
   'Find and replace routines by Charles Dietz
   'nOpt =  0  find dialog
   '     =  1  replace dialog
   '     =  3  find next
   '     = -3  find prev
   'find state remembered when [keep dialog open] checkbox is cleared
   'set start and finish selection variables on return
   'return true if text is changed by replace
   '-------------------------------------------------------------------
   LOCAL hFindRepl, j, k, m, n, nPos, ndir AS LONG
   LOCAL ti, findTxt AS STRING
   '-------------------------------------------------------------------
   STATIC ncase AS LONG
   STATIC parmsPtr AS LONG PTR
   'hold 5 parameters to be passed from callback in parms(4) array
   'parms(4) holds k, j, nOpt, whole, ncase
   DIM parms(4) AS LONG
   parmsPtr = VARPTR(parms(0))
   '-------------------------------------------------------------------
   IF ABS(nOpt) = 3 THEN 'find next with F3, or prev with Shft+F3
      IF nOpt > 0 THEN ndir = 0 ELSE ndir = 1
      findTxt = edmTxtGetSelText(hEdit, 1)
      IF LEN(findTxt) = 0 THEN findTxt = findTxtLast
      IF LEN(findTxt) = 0 THEN EXIT FUNCTION
      findTxtLast = findTxt
      nPos = myFindNext(findTxt, whole, ncase, ndir)
      m = SendMessage(hEdit, %EDM_GETTOPLINE, 0, 0)
      n = SendMessage(hEdit, %EDM_GETCARETY, 0, 0)
      IF (n-m+1) > displayLines OR n < m THEN SendMessage hEdit, %EDM_SETTOPLINE, n, 1
      DECR nPos: SendMessage hEdit, %EDM_SETSEL, nPos, nPos + LEN(findTxt)
      SendMessage hEdit, %EDM_REFRESH, 0, 0
      updateStatus: EXIT FUNCTION
   ELSE 'show find dialog
      whole = 1
      m = 120: n = 10: ti = "Find Text"
      IF nOpt THEN m = 0: n = 20: ti = "Find & Replace Text"
   END IF
   parms(2) = nOpt: parms(3) = whole: parms(4) = ncase
   DIALOG NEW 0, ti, , , 285, 150 + n, %WS_SYSMENU TO hFindRepl
   CONTROL ADD LABEL, hFindRepl, -1, "&What:", 10, 10, 25, 10
   CONTROL ADD TEXTBOX, hFindRepl, %IDC_What, "", 40, 10, 140, 12
   CONTROL ADD LABEL, hFindRepl, %IDC_WithLabel, "&With:", 10, 30, 25, 10
   CONTROL ADD TEXTBOX, hFindRepl, %IDC_With, "", 40, 30, 140, 12

   CONTROL ADD LABEL, hFindRepl, -1, "Options", 10, 30 + n, 100, 10
   CONTROL ADD CHECKBOX, hFindRepl, %IDC_Whole, "Match &whole word", 10, 45 + n, 80, 10  ', %WS_GROUP
   CONTROL ADD CHECKBOX, hFindRepl, %IDC_Case, "Match &case", 10, 60 + n, 80, 10
   CONTROL ADD CHECKBOX, hFindRepl, %IDC_Keep, "Keep dialog open", 10, 75 + n, 80, 10

   CONTROL ADD LABEL, hFindRepl, -1, "Range", 120, 30 + n, 100, 10
   CONTROL ADD OPTION, hFindRepl, %IDC_CurFile, "Current file", 120, 45 + n, 60, 10, %WS_GROUP
   CONTROL ADD OPTION, hFindRepl, %IDC_AllFiles, "All files", 120, 60 + n, 60, 10
   CONTROL ADD OPTION, hFindRepl, %IDC_CurSubFcn, "Current Sub/Fcn", 120, 75 + n, 70, 10

   CONTROL ADD LABEL, hFindRepl, %IDC_Direction, "Direction", 210, 30 + n, 50, 10
   CONTROL ADD OPTION, hFindRepl, %IDC_Up, "&Up", 210, 45 + n, 40, 10, %WS_GROUP
   CONTROL ADD OPTION, hFindRepl, %IDC_Down, "&Down", 210, 60 + n, 40, 10

   CONTROL ADD BUTTON, hFindRepl, %IDOK, "&Find", 10 + m, 100 + n, 50, 20, %WS_GROUP OR %WS_TABSTOP
   CONTROL ADD BUTTON, hFindRepl, %IDC_Replace, "&Replace", 65, 100 + n, 50, 20
   CONTROL ADD BUTTON, hFindRepl, %IDC_ReplaceAll, "&Replace all", 120, 100 + n, 50, 20
   CONTROL ADD BUTTON, hFindRepl, %IDCANCEL, "Cancel", 200, 100 + n, 50, 20

   IF nOpt THEN
      CONTROL HIDE hFindRepl, %IDC_Keep
      CONTROL HIDE hFindRepl, %IDC_Direction
      CONTROL HIDE hFindRepl, %IDC_Up
      CONTROL HIDE hFindRepl, %IDC_Down
   ELSE
      CONTROL HIDE hFindRepl, %IDC_WithLabel
      CONTROL HIDE hFindRepl, %IDC_With
      CONTROL HIDE hFindRepl, %IDC_Replace
      CONTROL HIDE hFindRepl, %IDC_ReplaceAll
   END IF

   CONTROL SET OPTION hFindRepl, %IDC_CurFile, %IDC_CurFile, %IDC_CurSubFcn
   CONTROL SET OPTION hFindRepl, %IDC_Down, %IDC_Up, %IDC_Down
   IF getBounds(1) = 0 THEN CONTROL DISABLE hFindRepl, %IDC_CurSubFcn
'   SetWindowPos(hFindRepl, %HWND_TOPMOST, 0, 0, 0, 0, %SWP_NOMOVE Or %SWP_NOSIZE)
   DIALOG SET USER hFindRepl, 1, parmsPtr
   DIALOG SHOW MODELESS hFindRepl CALL myFindReplaceProc
   DO
      DIALOG DOEVENTS 0
   LOOP WHILE ISWIN(hDlg) AND ISWIN(hFindRepl)
   j = @parmsPtr[0]: k = @parmsPtr[1]
   nOpt = @parmsPtr[2]: IF ABS(nOpt) THEN j = -1
   whole = @parmsPtr[3]: ncase = @parmsPtr[4]
   SendMessage hEdit, %EDM_SETSEL, j, k
   IF nOpt < 0 THEN FUNCTION = 1
END FUNCTION

CALLBACK FUNCTION myFindReplaceProc()
   LOCAL j, k, m, n, nPos, ndir, ncase, keep AS LONG                           
   LOCAL s, findTxt, replaceTxt AS STRING
   STATIC nOpt, nSel AS LONG
   STATIC parmsPtr AS LONG PTR
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         DIALOG GET USER CBHNDL, 1 TO parmsPtr
         nOpt = @parmsPtr[2]: whole = @parmsPtr[3]: ncase = @parmsPtr[4]
         saveThisTab = thisTab: nSel = 0: nReplace = 0
         subFcnRange = 0: getBounds                                      'default startPos, endPos
         j = SendMessage(hEdit, %EDM_GETSELPOSSTART, 0, 0)               'start of text to search
         k = SendMessage(hEdit, %EDM_GETSELPOSEND, 0, 0)                 'end of text to search
         findTxt = edmTxtGetSelText(hEdit, 1)                            'get selected text
         IF LEN(findTxt) = 0 THEN findTxt = findTxtLast
         CONTROL SET TEXT CB.HNDL, %IDC_What, findTxt                    'initial text to search for
         CONTROL SET CHECK CB.HNDL, %IDC_Whole, whole
         CONTROL SET CHECK CB.HNDL, %IDC_Case, ncase
         CONTROL SET FOCUS CB.HNDL, %IDC_What
         IF nOpt AND LEN(findTxt) THEN CONTROL SET FOCUS CBHNDL, %IDC_With
      CASE %WM_COMMAND
         IF CBCTL = %IDOK THEN 'find text
            IF allFiles THEN
               FOR n = 1 TO numTabs                               
                  IF pageLoaded(n) = 0 THEN                      
                     edmSetText edmHandles(n), fileText(n)
                     pageLoaded(n) = 1
                  END IF
               NEXT n
            END IF
            CONTROL GET TEXT CBHNDL, %IDC_What TO findTxt
            IF LEN(findTxt) = 0 THEN
               MSGBOX "Must specify what to find", %MB_ICONERROR, "Find Text"
               CONTROL SET FOCUS CB.HNDL, %IDC_What
               EXIT FUNCTION
            END IF
            CONTROL GET CHECK CBHNDL, %IDC_Whole TO whole
            CONTROL GET CHECK CBHNDL, %IDC_Case TO ncase
            CONTROL GET CHECK CBHNDL, %IDC_Keep TO keep
            CONTROL GET CHECK CBHNDL, %IDC_Down TO k
            IF k THEN ndir = 0 ELSE ndir = 1
            nPos = myFindNext(findTxt, whole, ncase, ndir)
            IF nPos THEN nSel = nPos
            IF nPos > 0 THEN  'process if found
               DECR nPos  'account for start of selection - 1
               SendMessage hEdit, %EDM_SETSEL, nPos, nPos+LEN(findTxt)
               SendMessage hEdit, %EDM_REFRESH, 0, 0
               m = SendMessage(hEdit, %EDM_GETTOPLINE, 0, 0)
               n = SendMessage(hEdit, %EDM_GETCARETY, 0, 0)
               IF (n-m+1) > displayLines OR n < m THEN
                  SendMessage hEdit, %EDM_SETTOPLINE, n, 1
                  SetFocus CB.HNDL
               END IF
               findTxtLast = findTxt
               @parmsPtr[0] = nPos: @parmsPtr[1] = nPos + LEN(findTxt)
               @parmsPtr[3] = whole: @parmsPtr[4] = ncase
               IF nOpt OR keep THEN
                  whole = 1: ncase = 0
               ELSE
                  DIALOG send CB.HNDL, %WM_SYSCOMMAND, %SC_CLOSE, 0
               END IF
               updateStatus
            ELSEIF nPos = 0 THEN
               IF nSel THEN s = "Finished" ELSE s = "None found"
               MSGBOX s, %MB_ICONINFORMATION, "Find Text"
               nSel = 0
               DIALOG send CB.HNDL, %WM_SYSCOMMAND, %SC_CLOSE, 0
            END IF
         ELSEIF CBCTL = %IDC_Replace THEN 'replace found text
            nReplace = 1
            CONTROL GET TEXT CB.HNDL, %IDC_What TO findTxt
            CONTROL GET TEXT CB.HNDL, %IDC_With TO replaceTxt
            IF LEN(findTxt) = 0 OR LEN(replaceTxt) = 0 THEN
               s = "Must specify both what to replace and with what"
               MSGBOX s, %MB_ICONERROR, "Replace Text"
               IF LEN(findTxt) = 0 THEN n = %IDC_What ELSE n = %IDC_With
               CONTROL SET FOCUS CB.HNDL, n: EXIT FUNCTION
            END IF
            n = SendMessage(hEdit, %EDM_GETSELLENGTH, 0, 0)
            IF n THEN
               SendMessage hEdit, %EDM_REPLACESEL, STRPTR(replaceTxt), 1
               IF subFcnRange THEN getBounds
            END IF
            DIALOG SEND CB.HNDL, %WM_COMMAND, %IDOK, 0
            SetFocus CB.HNDL
         ELSEIF CBCTL = %IDC_ReplaceAll THEN 'replace all
            CONTROL GET CHECK CBHNDL, %IDC_Whole TO whole
            CONTROL GET CHECK CBHNDL, %IDC_Case TO ncase
            CONTROL GET TEXT CBHNDL, %IDC_What TO findTxt
            CONTROL GET TEXT CBHNDL, %IDC_With TO replaceTxt
            IF LEN(findTxt) = 0 OR LEN(replaceTxt) = 0 THEN
               s = "Must specify both what to replace and with what"
               MSGBOX s, %MB_ICONERROR, "Replace All"
               IF LEN(findTxt) = 0 THEN n = %IDC_What ELSE n = %IDC_With
               CONTROL SET FOCUS CB.HNDL, n: EXIT FUNCTION
            END IF
            s = "Use extreme caution with this option" + $CRLF _
              + "... do you still want to proceed?"
            n = MSGBOX(s, %MB_ICONWARNING OR %MB_YESNO, "Replace All")
            IF n = %IDNO THEN EXIT FUNCTION
            ndir = 0: SendMessage hEdit, %EDM_SETSEL, startPos, startPos   'begin at startPos
            DO 'scan range, replacing text
               nPos = edmTxtFindNext(hEdit, findTxt, ndir, ncase, whole, 0)
               IF nPos = 0 THEN 'none found
                  IF allFiles THEN 'switch to next tab
                     srchNextTab(ndir)
                     IF thisTab = saveThisTab THEN EXIT DO
                     nPos = -1: ITERATE
                  END IF
               ELSEIF nPos >= startPos AND nPos <= endPos THEN
                  SendMessage hEdit, %EDM_REPLACESEL, STRPTR(replaceTxt), 0
                  SendMessage hEdit, %EDM_REFRESH, 0, 0
                  nSel = nPos: IF subFcnRange THEN getBounds
               ELSE  'this block only for sub/fcn range
                  SendMessage hEdit, %EDM_SETSEL, nSel, nSel
                  SendMessage hEdit, %EDM_RESETSEL, 0, 1
                  nPos = 0: nSel = 0  'done
               END IF
            LOOP UNTIL nPos = 0
            DIALOG send CB.HNDL, %WM_SYSCOMMAND, %SC_CLOSE, 0
         ELSEIF CB.CTL = %IDCANCEL THEN
            DIALOG send CB.HNDL, %WM_SYSCOMMAND, %SC_CLOSE, 0
         ELSEIF CB.CTL = %IDC_CurFile AND CB.CTLMSG = %BN_CLICKED THEN
            subFcnRange = 0: allFiles = 0
            startPos = 0: endPos = SendMessage(hEdit, %EDM_GETTEXTLEN, 0, 0)
         ELSEIF CB.CTL = %IDC_AllFiles AND CB.CTLMSG = %BN_CLICKED THEN
            allFiles = 1: subFcnRange = 0
         ELSEIF CB.CTL = %IDC_CurSubFcn AND CB.CTLMSG = %BN_CLICKED THEN
            subFcnRange = 1: getBounds: allFiles = 0
         END IF
      CASE %WM_SYSCOMMAND
         IF CB.CTL = %SC_CLOSE THEN
            n = SendMessage(hEdit, %EDM_GETTEXTLEN, 0, 0)
            if n > len(fileText(thisTab)) then
               fileText(thisTab) = space$(n)
               SendMessage hEdit, %EDM_GETTEXT, STRPTR(fileText(thisTab)), n
            end if
            DIALOG END CBHNDL, parmsPtr
         END IF
   END SELECT
END FUNCTION

FUNCTION getBounds(OPT BYVAL ck AS LONG) AS LONG
   'the optional ck parameter is used to check if cursor is in sub or fcn
   LOCAL i, j, k, n, numLines AS LONG
   LOCAL s, ss, sLine AS STRING
   IF subFcnRange OR ck THEN  'get startPos and endPos for sub/fcn range
      i = SendMessage(hEdit, %EDM_GETCARETY, 0, 0): j = i
      DO 'scan for start of sub/fcn
         sLine = edmTxtGetLine(hEdit, i)
         n = INSTR(sLine, "'")
         IF n THEN sLine = LEFT$(sLine, n-1)
         s = UCASE$(LTRIM$(sLine))
         IF LEFT$(s, 8) = "FUNCTION" THEN
            s = LTRIM$(MID$(s, 9)): ss = LEFT$(s, 1)
            IF ss <> "=" THEN FUNCTION = 2: EXIT DO
         ELSEIF LEFT$(s, 17) = "CALLBACK FUNCTION" THEN
            FUNCTION = 3: EXIT DO
         ELSEIF LEFT$(s, 3) = "SUB" THEN
            FUNCTION = 1: EXIT DO
         ELSE
            k = LEFT$(s, 7) = "END SUB" OR LEFT$(s, 12) = "END FUNCTION"
            IF i = 0 OR (i < j AND k) THEN
               startPos = 0: endPos = SendMessage(hEdit, %EDM_GETTEXTLEN, 0, 0)
               subFcnRange = 0: FUNCTION = 0: EXIT FUNCTION
            END IF
         END IF
         DECR i
      LOOP WHILE i >= 0  'lines are base 0

      startPos = edmTxtGetPos(hEdit, 0, i)
      numLines = SendMessage(hEdit, %EDM_GETLINECOUNT, 0, 0)
      DO 'scan for end of sub/fcn
         sLine = edmTxtGetLine(hEdit, j)
         n = INSTR(sLine, "'"): IF n THEN sLine = LEFT$(sLine, n-1)
         ss = LTRIM$(sLine): sLine = UCASE$(ss)
         IF LEFT$(sLine, 12) = "END FUNCTION" THEN k = 12: EXIT DO
         IF LEFT$(sLine, 7) = "END SUB" THEN k = 7: EXIT DO
         INCR J
      LOOP WHILE j <= numLines
      endPos = edmTxtGetPos(hEdit, k, j)
   ELSE  'get default startPos and endPos for full file
      startPos = 1: endPos = SendMessage(hEdit, %EDM_GETTEXTLEN, 0, 0)
   END IF
END FUNCTION

SUB srchNextTab(ndir AS LONG)
   LOCAL n AS LONG
   IF ndir = 0 THEN 'searching forward
      INCR thisTab: IF thisTab > numTabs THEN thisTab = 1
   ELSE 'searching backward
      DECR thisTab: IF thisTab < 1 THEN thisTab = numTabs
   END IF
   TAB SELECT hDlg, %IDC_Tab, thisTab
   hEdit = edmHandles(thisTab)
   'n = SendMessage(hEdit, %EDM_GETTEXTLEN, 0, 0)
   'fileText(thisTab) = SPACE$(n)
   'SendMessage hEdit, %EDM_GETTEXT, STRPTR(fileText(thisTab)), n
   'edmSetText hEdit, fileText(thisTab)  'copy text into editor
   endPos = SendMessage(hEdit, %EDM_GETTEXTLEN, 0, 0)
   IF ndir THEN n = endPos ELSE n = startPos
   SendMessage hEdit, %EDM_SETSEL, n, n
END SUB

SUB moveTab(nDir AS LONG)
   'nDir = 1 then move tab right, -1 then move tab left
   'two adjacent tabs will be swapped... the clicked one and the next (or prev)
   '----------------------------------------------------------------------------------
   LOCAL cursorPos, cursorPos1, topLine, topLine1 AS LONG
   LOCAL changed, changed1, hEdt, hEdt1, clickedTab1 AS LONG

   IF nDir < 0 THEN clickedTab1 = clickedTab-1 ELSE clickedTab1 = clickedTab+1
   hEdt = edmHandles(clickedTab): hEdt1 = edmHandles(clickedTab1)
   fileText(clickedTab) = edmTxtGetSelText(hEdt, 0)

   'save cursor positions, top visible lines, and change status
   changed = SendMessage(hEdt, %EDM_GETCHANGED, 0, 0)
   changed1 = SendMessage(hEdt1, %EDM_GETCHANGED, 0, 0)
   cursorPos = SendMessage(hEdt, %EDM_GETCARETPOS, 0, 0)
   cursorPos1 = SendMessage(hEdt1, %EDM_GETCARETPOS, 0, 0)
   topLine = SendMessage(hEdt, %EDM_GETTOPLINE, 0, 0)
   topLine1 = SendMessage(hEdt1, %EDM_GETTOPLINE, 0, 0)

   SWAP pageHandles(clickedTab), pageHandles(clickedTab1)
   SWAP fileNames(clickedTab), fileNames(clickedTab1)
   SWAP fileText(clickedTab), fileText(clickedTab1)
   'swap edmHandles(clickedTab), edmHandles(clickedTab1)

   'replace text in each tab by the other
   SendMessage hEdt, %EDM_SETSEL, 0, -1
   edmSetText hEdt, fileText(clickedTab)
   pageLoaded(clickedTab1) = 1
   SendMessage hEdt1, %EDM_SETSEL, 0, -1
   edmSetText hEdt1, fileText(clickedTab1)
   pageLoaded(clickedTab) = 1

   'update and center tab text
   TAB SET TEXT hDlg, %IDC_Tab, clickedTab, PATHNAME$(NAMEX, fileNames(clickedTab))
   TAB SET TEXT hDlg, %IDC_Tab, clickedTab1, PATHNAME$(NAMEX, fileNames(clickedTab1))
   CONTROL SEND hDlg, %IDC_Tab, %TCM_SETITEMSIZE, 0, MAK(DWORD, xTab-1, yTab) 'work around to center text
   CONTROL SEND hDlg, %IDC_Tab, %TCM_SETITEMSIZE, 0, MAK(DWORD, xTab, yTab)

   'reapply cursor positions, visible lines, and change status
   IF clickedTab = thisTab THEN
      thisTab = clickedTab1
   ELSEIF clickedTab1 = thisTab THEN
      thisTab = clickedTab
   END IF
   TAB SELECT hDlg, %IDC_Tab, thisTab
   thisFile = fileNames(thisTab)
   hEdit = edmHandles(thisTab)
   SetFocus hEdt1
   SendMessage hEdt1, %EDM_SETCARETPOS, cursorPos, 0
   SendMessage hEdt1, %EDM_SETTOPLINE, topLine, 0
   SendMessage hEdt1, %EDM_UNDOCLEAR, 0, 0
   SetFocus hEdt
   SendMessage hEdt, %EDM_SETCARETPOS, cursorPos1, 0
   SendMessage hEdt, %EDM_SETTOPLINE, topLine1, 0
   SendMessage hEdt, %EDM_UNDOCLEAR, 0, 0
   SetFocus hEdit
   SendMessage hEdit, %EDM_REFRESH, 0, 0
   updateStatus
   SendMessage hEdt1, %EDM_SETCHANGED, changed, 0
   SendMessage hEdt, %EDM_SETCHANGED, changed1, 0
END SUB

'-------------------------------------------------------------------------------
'About dialog
'-------------------------------------------------------------------------------
SUB about()
   LOCAL hAbout AS LONG, s AS STRING
   DIALOG NEW hDlg,"About My PBEditor",,, 220, 160, %WS_SYSMENU TO hAbout
   CONTROL ADD LABEL, hAbout, 9901, "my PBEditor", 50, 10, 80, 20
   CONTROL ADD LABEL, hAbout, 9902, " for Windows", 120, 13, 70, 10                 
   s = "(Based on EDM32 by Borje Hagsten)"
   CONTROL ADD LABEL, hAbout, 9906, s, 50, 25, 125, 15
   s = "Version " + $verNo + " - Free distribution" + $CRLF
   s = s + "by Charles G. Dietz" + $CRLF + $CRLF
   CONTROL ADD LABEL, hAbout, 9903, s, 50, 45, 180, 30
   s = "chasdietz@verizon.net"
   CONTROL ADD LABEL, hAbout, 9904, s, 60, 80, 140, 12, %SS_NOPREFIX OR %SS_NOTIFY
   s = "http://www.cgdsoftware.com"
   CONTROL ADD LABEL, hAbout, 9905, s, 60, 95, 140, 12, %SS_NOPREFIX OR %SS_NOTIFY
   CONTROL ADD IMAGE, hAbout, -1, "LibrList", 10, 10, 30, 30
   DIALOG SHOW MODAL hAbout, CALL aboutProc
END SUB

CALLBACK FUNCTION aboutProc()
   LOCAL hFont AS LONG
   LOCAL url, email AS ASCIIZ*64
   SELECT CASE CB.MSG
   CASE %WM_PAINT
      FONT NEW "MS Sans Serif", 14 TO hFont
      CONTROL SET COLOR CB.HNDL, 9901, %RED, -1
      CONTROL SET FONT CB.HNDL, 9901, hFont
      FONT NEW "MS Sans Serif", 10, 2 TO hFont
      CONTROL SET FONT CB.HNDL, 9902, hFont
      FONT NEW "MS Sans Serif", 10 TO hFont
      CONTROL SET FONT CB.HNDL, 9903, hFont
      CONTROL SET COLOR CB.HNDL, 9906, hFont, -1
      FONT NEW "MS Sans Serif", 10, 4 TO hFont
      CONTROL SET COLOR CB.HNDL, 9904, %BLUE, -1
      CONTROL SET FONT CB.HNDL, 9904, hFont
      FONT NEW "MS Sans Serif", 10, 4 TO hFont
      CONTROL SET COLOR CB.HNDL, 9905, %BLUE, -1
      CONTROL SET FONT CB.HNDL, 9905, hFont
      FONT END hFont
   CASE %WM_SETCURSOR  'Change cursor to hand when hovering over label
      IF GetDlgCtrlId(CBWPARAM) >= 9904 THEN
         SetCursor LoadCursor(GetModuleHandle(""), "HAND")
         SetWindowLong CB.HNDL, %DWL_MSGRESULT, 1: FUNCTION = 1
      END IF
   CASE %WM_COMMAND
      IF CB.CTL = %IDOK OR CB.CTL = %IDCANCEL THEN
         DIALOG END CB.HNDL
      ELSEIF CB.CTL = 9904 THEN
         MOUSEPTR 11
         email = "chasdietz@verizon.net"
         ShellExecute(0, "open", "mailto:" + email + "?", "", "", %SW_SHOW)
      ELSEIF CB.CTL = 9905 THEN
         MOUSEPTR 11
         url = "http://www.cgdsoftware.com"
         ShellExecute(BYVAL %NULL, "open", url, BYVAL %NULL, BYVAL %NULL,%SW_SHOWMAXIMIZED)
      END IF
   END SELECT
END FUNCTION
